// StrCalc - partial: proc func

// #partial MCEvaler

#include "hspda.as"

//**********************************************************
//        gݍ݊֐̎
//**********************************************************
#define ctype argvar(%1) vector_Get(arglist, %1)
#define ctype argv(%1) var_Get    ( argvar(%1) )
#define ctype argt(%1) var_GetType( argvar(%1) )
#define ctype arg_GetValue(%1, %2 = resVt) var_GetValue( argvar(%1), %2 )

//------------------------------------------------
// gݍ݊֐(System)
// 
// @in evaler
//------------------------------------------------
#modcfunc evaler_ProcFuncSystem int thisAssoc, int iFunc, var resVt, int arglist, int cntArgs,  \
	local result, local tmp, local tmp_vt, \
	local iVar, \
	local iFuncNew, local prmlist, local block, \
	local iSuper, local iCtor, local lhs_var, local lhs_vt, local lhs, local rhs_var, local rhs_vt, local rhs
	
	switch ( iFunc )
		// new(*)
		case Func_System_New:
			
			// this Ȃ =>  this Ƃ
			if ( thisAssoc == assocNull ) {
				if ( cntArgs == 0 ) {			// new() => Aẑ𐶐
					resVt = Valtype_Assoc
					return new_assoc( miEnv )
				}
				
				tmp = evaler_GetValueFromArglist( thismod, arglist, 0, tmp_vt, false )
				if ( stt_error ) { PutError }
				
				vector_PopFront arglist			// 擪̈
				
			// this 
			} else {
				tmp    = thisAssoc
				tmp_vt = Valtype_Assoc
			}
			
			// Az(NX or CX^X)
			if ( tmp_vt == Valtype_Assoc ) {
			;	tmp  prototype-assoc
				
				result = new_assoc(miEnv)		// Az
				
				// this.prototype
				assoc_DefVar result, "prototype", tmp, Valtype_Assoc
				
				// RXgN^s ( apply( prototype.Ctor, arglist... ) )
				iVar = assoc_Find( tmp, "ctor", true )		// (true: prototype-chain 猟Ȃ)
				if ( iVar > 0 ) {
					if ( var_GetType(iVar) == Valtype_Func ) {
					;	if ( PluginId(var_Get(iVar)) != PlugIn_Userdef ) {
					;		logmes "[Warning] when ֐Ăяo(new)\n[U`֐łȂ֐ new łȂB"
					;	}
						tmp = evaler_CallFunc( thismod, resVt, (result), var_Get(iVar), arglist )
					} else {
						logmes "[Error] when ֐Ăяo(new)\n.ctor ͊֐^ɌB"
						PutError Error_NeedFunc
					}
				}
				
			//  => new-call
			} elsif ( tmp_vt == Valtype_Block ) {
			;	tmp  block
				if ( vector_Size(arglist) > 0 ) { PutError Error_Argc }
				result = new_assoc(miEnv)		// thisAz
				tmp    = evaler_ProcBlock( thismod, result, tmp, resVt )	// new-call
				
			// ֐
			} elsif ( tmp_vt == Valtype_Func ) {
			;	tmp  valFunc
				
				// Type-func => Ăяo
				if ( PluginId(tmp) == PlugIn_Type ) {
					return evaler_CallFunc( thismod, resVt, assocNull, tmp, arglist )
					
				// userdef-func => new-call 
				} elsif ( PluginId(tmp) == PlugIn_Userdef ) {
					result = new_assoc(miEnv)
					tmp    = evaler_CallFunc( thismod, resVt, (result), tmp, arglist )	// ֐Ăяo
					
				} else {
					logmes "[Warning] when ֐Ăяo(new)\n[U`֐łȂ֐ new łȂB"
				}
				
			// !error (\bh)
			} elsif ( tmp_vt == Valtype_Method ) {
				PutErrorMsg "\bh new łȂB"
				
			// !error
			} else {
				logmes "[Error] when vZ\ngݍ݊֐ new ُ̈Barglist = " + arglist + ", [0] " + dbgpair(tmp, tmp_vt)
				PutError Error_NeedFunc
			}
			
			resVt = Valtype_Assoc
			return result
			
		// namespace( block )
		case Func_System_Namespace:
			if ( cntArgs != 1 ) { PutError Error_Argc }
			
			lhs = evaler_GetValueFromArglist( thismod, arglist, 0, lhs_vt, false, Valtype_Block )
			env_new tmp, miEnv										// V𐶐
			lhs = evaler_ProcBlockHere( thismod, lhs, lhs_vt, tmp )	// s (̓_~[)
			
			resVt = Valtype_Assoc
			return env_GetAssoc(tmp)	// s̋ǏAẑԋp
			
		// call( callable, arglist... )
		case Func_System_Call:
			if ( cntArgs == 0 ) { PutError Error_Argc }
			
			// 
			lhs = evaler_GetValueFromArglist( thismod, arglist, 0, lhs_vt, false )
			if ( not EnumRange_Valtype_Callable(lhs_vt) ) { PutError Error_NeedCallable }
			
			// ֐Ăяo̎s (c̈n)
			return evaler_CallOpUni_List( thismod, PostfixOp_Call, resVt, lhs, lhs_vt, vector_Slice(arglist, 1) )
			
		// apply, index ( callable, vector (as list) )
		case Func_System_Apply:
		case Func_System_Index:
			if ( cntArgs != 2 ) { PutError Error_Argc }
			
			lhs = evaler_GetValueFromArglist( thismod, arglist, 0, lhs_vt, false )		// func or method or assoc[with opAssocBind]
			rhs = evaler_GetValueFromArglist( thismod, arglist, 1, rhs_vt, false, Valtype_Assoc )
			if ( stt_error ) { PutError }
			dbgout dbgpair( lhs, lhs_vt )
			if ( iFunc == Func_System_Apply && not EnumRange_Valtype_Callable (lhs_vt) ) { PutError Error_NeedCallable  }
			if ( iFunc == Func_System_Index && not EnumRange_Valtype_Indexable(lhs_vt) ) { PutError Error_NeedIndexable }
			
			// s֐̈Xg(rhs)
			if ( not assoc_InstOf(rhs, stt_assoc_vector) ) { PutError Error_NeedVector }
			
			// Ăяo̎s
			return evaler_CallOpUni_List( thismod, which(iFunc == Func_System_Apply, PostfixOp_Call, PostfixOp_Index), resVt, lhs, lhs_vt, (rhs) )
			
		// bind( func, this )
		case Func_System_Bind:
			if ( cntArgs != 2 ) { PutError Error_Argc }
			
			lhs = evaler_GetValueFromArglist( thismod, arglist, 0, lhs_vt, false )		// func or assoc[with AssocBind]
			rhs = evaler_GetValueFromArglist( thismod, arglist, 1, rhs_vt, false )
			if ( stt_error ) { return 0 }
			
			return evaler_ProcFuncSystem_Bind( thismod, resVt, lhs, lhs_vt, rhs, rhs_vt )
			
		// using( assoc )
		case Func_System_Using:
			if ( cntArgs != 1 ) { PutError Error_Argc }
			
			tmp = evaler_GetValueFromArglist( thismod, arglist, 0, tmp_vt, false, Valtype_Assoc )
			if ( tmp == assocNull ) { PutError Error_InvalidValue }
			env_Using miEnv, tmp		// AẑΏۂɒǉ
			
			resVt = Valtype_Assoc
			return tmp				// ̘Aẑ̂܂ܕԂ
			
		// runOn( block, block(for env) )
		case Func_System_RunOn:
			if ( cntArgs != 2 ) { PutError Error_Argc }
			
			env_new tmp, block_GetEnv( evaler_GetValueFromArglist( thismod, arglist, 1, resVt, false, Valtype_Block ) )	// s
			result = evaler_ProcBlockHere( thismod, evaler_GetValueFromArglist( thismod, arglist, 0, resVt, false, Valtype_Block ), resVt, tmp )
			
			if and( mExitMode == ExitMode_Break, mExitVt == Valtype_Func, mExitValue == FuncValue(PlugIn_System, Func_System_RunOn) ) {
				evaler_RemoveExit thismod
			}
			
			return result
			
		// has( assoc, member-ident )
		case Func_System_Has:
			if ( cntArgs != 2 ) { PutError Error_Argc }
			
			tmp = evaler_GetValueFromArglist( thismod, arglist, 0, tmp_vt, false, Valtype_Assoc )
			
			if ( argt(1) != Valtype_Ident ) { PutError Error_NeedIdent }
			
			resVt = Valtype_Bool
			return ( assoc_Find(tmp, argv(1)) >= 0 )
			
		// cond( pair<bool predicate, value or block> preds... )
		case Func_System_Cond:
			result = assocNull		// l(null)
			resVt  = Valtype_Assoc
			
			repeat cntArgs
				tmp = evaler_GetValueFromArglist( thismod, arglist, cnt, tmp_vt, false, Valtype_Assoc )
				if or( tmp == assocNull, assoc_GetPrototypeAssoc(tmp) != stt_assoc_pair ) {
					PutErrorImpl Error_NeedPair : break		// ΂Kv
				}
				
				//  (bool predicate)
				lhs = var_GetValue( assoc_Find(tmp, "lhs"), lhs_vt )
				if ( lhs_vt != Valtype_Bool ) { logmes "[Error] when ֐s(cond)\n΂̍ӂ bool łȂB" : stt_error = Error_NeedBool : break }
				
				if ( lhs != true ) { continue }		// ^łȂ => Eӂ𖳎Ď̈ᖡ
				
				// E ( or l(!))
				rhs = var_GetValue( assoc_Find(tmp, "rhs"), rhs_vt )
				
				if ( rhs_vt == Valtype_Block ) {
					result = evaler_ProcBlock( thismod, assocNull, rhs, resVt )	//  => s
					
					if ( mExitMode == ExitMode_Break && mExitVt == Valtype_Func && mExitValue == FuncValue(PlugIn_System, Func_System_Cond) ) {
						evaler_RemoveExit thismod
					}
				} else {
					resVt  = rhs_vt
					result = rhs
				}
				
				break
			loop
			if ( stt_error ) { PutError }
			
			return result
			
		// valof( value )
		case Func_System_ValOf:
			if ( cntArgs != 1 ) { PutError Error_Argc }
			resVt = argt(0)		// Ă΂ꂽ_ŉEӒlWJς
			return argv(0)
			
		// prop_remove( prop )
		case Func_System_PropRemove:
			if ( cntArgs != 1 ) { PutError Error_Argc }
			if ( argt(0) != Valtype_Ident ) { PutError Error_NeedIdent }
			
			resVt = Valtype_Var
			result = env_FindVar( miEnv, argv(0) )			// vpeBł͂ȂϐƂĎo
			if ( result < 0 ) { PutError Error_NeedVar }	// ` => G[
			
			var_Set result, assocNull, Valtype_Assoc
			return result
			
		// sum, prod
		case Func_System_Sum:
		case Func_System_Prod:
			return evaler_ProcFuncSystem_SumOrProd(thismod, iFunc, resVt, arglist, cntArgs)
			
		// n
		case Func_System_Argv:
			if ( cntArgs != 1 ) { PutError Error_Argc }
			if ( argt(0) != Valtype_Int ) { PutError Error_NeedInt }
			
			iVar = env_FindVar( miEnv, "arguments" )
			if ( iVar < 0 ) { PutErrorMsg "ɂ͈(arguments)`ĂȂB"  }
			
			resVt = Valtype_Var
			return vector_Get( var_Get(iVar), argv(0) )		// arguments[ argv(0) ]
			
		case Func_System_Argc:
			if ( cntArgs != 0 ) { PutError Error_Argc }
			resVt = Valtype_Int
			
			iVar = env_FindVar( miEnv, "arguments" )
			if ( iVar < 0 ) { return 0 }
			
			return vector_Size( var_Get(iVar) )			// arguments->size()
			
		default:
			assert
	swend
	
// bind( src, obj ) : src  obj 𑩔
#modcfunc evaler_ProcFuncSystem_Bind var resVt, var src, var src_vt, var obj, var obj_vt, \
	local arglist, local result
	
	// Aẑ𑩔
	if ( obj_vt == Valtype_Assoc ) {
		// ֐
		if ( src_vt == Valtype_Func || src_vt == Valtype_Method ) {
			
			if ( src_vt == Valtype_Method ) {	// \bh => 
				logmes "[Warning] \bh bind 悤ƂB"
				src    = Pair_getRhs(src)		// func ̂ݎo
				src_vt = Valtype_Func
			}
			
			if ( obj == assocNull ) {			// (null 𑩔) => 
				resVt = Valtype_Func
				return src
			} else {
				resVt = Valtype_Method
				return new_pair( obj, src )		// obj 𑩔
			}
			
		// Az̉Z
		} elsif ( src_vt == Valtype_Assoc ) {
			return evaler_ProcOpBin_Assoc( thismod, BinOp_AssocBind, (src), resVt, obj, obj_vt )
			
		} else {
			logmes "[Error] when ֐Ăяo(bind)\ُB"
			PutErrorMsg EnumString_Valtype(src_vt) + " ^̒lɂ͑(bind)łȂB"
		}
		
	// Aẑ𑩔 => Y : bind( src, val[<:! assoc] )  src[val]
	} else {
		arglist = new_vector( miEnv )		// arglist  [ obj ]
		vector_PushBack arglist, obj, obj_vt
		result = evaler_CallOpUni_List( thismod, PostfixOp_Index, resVt, src, src_vt, arglist )
		
	;	result = StrCalc_BindFunc( src, arglist, miEnv )
	;	resVt  = Valtype_Func
		return result
	}
	assert
	
// , 
#modcfunc evaler_ProcFuncSystem_SumOrProd int iFunc, var resVt, int arglist, int cntArgs,  \
	local result, local prmlist, local tmp, local tmp_vt, \
	local ident,  local defcnt,  local maxcnt, local block,  \
	local iEnvNxt, local iVar, local nowcnt
	
	if ( cntArgs != 4 ) { PutError Error_Argc }
	
	result = which( (iFunc == Func_System_Sum), 0.0, 1.0 )
	
	// `FbN : ( ident, int, int, block )
	dim prmlist, 4, 2
		prmlist(0, 0) = Valtype_Ident, Valtype_Int, Valtype_Int, Valtype_Block
		prmlist(0, 1) = true,          false,       false,       false
	
	repeat cntArgs
		tmp = evaler_GetValueFromArglist( thismod, arglist, cnt, tmp_vt, prmlist(cnt, 1), prmlist(cnt, 0) )
;		dbgout dbgpair(tmp, tmp_vt)
		if ( stt_error ) { break }
		switch ( cnt )
			xcase 0: ident  = tmp		// JE^ϐ̎ʎq
			xcase 1: defcnt = tmp		// l
			xcase 2: maxcnt = tmp		// ől
			xcase 3: block  = tmp		// s
		swend
	loop
	if ( stt_error ) { PutError }
	
	if ( defcnt > maxcnt ) { resVt = Valtype_Int : return int(result) }
	
	// V̐
	env_New      iEnvNxt, miEnv
	assoc_DefVar env_GetAssoc(iEnvNxt), ident, defcnt, Valtype_Int	// JE^ϐ
	iVar = stat
	
	logmes "(|)[" + var_GetName(iVar) + ": " + defcnt + "" + maxcnt + "]( " + DecodeValue_Block(block) + " )"
	
	// ̎s
	repeat
		// s
		tmp = evaler_ProcBlockHere( thismod, block, tmp_vt, iEnvNxt )
		;{
			if and( mExitMode == ExitMode_Break, mExitVt == Valtype_Func, mExitValue == FuncValue(PlugIn_Syntax, iFunc) ) {
				evaler_RemoveExit thismod
			}
			if ( mExitMode != ExitMode_None ) { break }
		;}
		evaler_ExpandValueAsRVal thismod, tmp, tmp_vt
		if ( not EnumRange_Valtype_Numeric(tmp_vt) ) { stt_error = Error_NeedDouble : break }
		
		// vZ
		if ( iFunc == Func_System_Sum ) {
			result += tmp
		} else /* : if ( iFunc == Func_System_Prod ) */ {
			result *= tmp
		}
		
		// XV
		if ( var_GetType(iVar) != Valtype_Int ) { PutErrorMsg "JE^ϐ int ^ɂȂB" }
		
		nowcnt = var_Get(iVar)
		if ( nowcnt == maxcnt ) {		// I
			break
		} else {
			var_Set iVar, nowcnt + 1, Valtype_Int
		}
	loop
	if ( stt_error ) { PutError }
	
	// ԋp
;	if ( mExitMode != ExitMode_None ) { resVt = mResVt : return mResult }
	if ( IsDoubleInt(result) ) {
		resVt = Valtype_Int
		return int( result )
	} else {
		resVt = Valtype_Double
		return result
	}
	
//------------------------------------------------
// gݍ݊֐(Dev)
// 
// @in evaler
//------------------------------------------------
#modcfunc evaler_ProcFuncDev int thisAssoc, int iFunc, var resVt, int arglist, int cntArgs, \
	local tmp, local tmp_vt
	
	switch ( iFunc )
		// putError(val) : G[f
		case Func_Dev_PutError:
			tmp = evaler_GetValueFromArglist( thismod, arglist, 0, tmp_vt, false )
			PutErrorMsg "(user)\n" + DecodeEvalElem(tmp_vt, tmp)
			
		// decode( val ) : fR[h
		case Func_Dev_Decode:
			tmp = evaler_GetValueFromArglist( thismod, arglist, 0, tmp_vt, false )
			resVt = Valtype_String
			return DecodeEvalElem( tmp_vt, tmp )
			
		// lcAssoc() : ǏAẑ̎擾
		case Func_Dev_LcAssoc:
			resVt = Valtype_Assoc
			dbgout dbgpair( miEnv, env_GetAssoc(miEnv) )
			return env_GetAssoc(miEnv)
			
		default:
			assert
	swend
	
//------------------------------------------------
// gݍ݊֐(Syntax)
// 
// @in evaler
//------------------------------------------------
#modcfunc evaler_ProcFuncSyntax int thisAssoc, int iFunc, var resVt, int arglist, int cntArgs, \
	local tmp
	
	switch ( iFunc )
		// return
		// yield
		case Func_Syntax_Return:
		case Func_Syntax_Yield:
			if ( cntArgs == 0 ) {		// ԒlȂ => null ԋp
				resVt = Valtype_Assoc
				tmp   = assocNull
			} elsif ( cntArgs == 1 ) {
				tmp = evaler_GetValueFromArglist( thismod, arglist, 0, resVt, true )	// EӒlWJȂ
			} else {
				vector_BeTuple arglist
				tmp = arglist			// 𑽒lƂĕԂ
			}
			
			if ( iFunc == Func_Syntax_Return ) {
				evaler_SetExit thismod, ExitMode_Return, tmp, resVt
			} else {
				evaler_Yield thismod				// yield wo
				PushToStack mStkCalc, tmp, resVt	// Ԓlpɂς
			}
			return tmp
			
		// break( func )
		case Func_Syntax_Break:
			if ( cntArgs != 1 ) { PutError Error_Argc }
			tmp = evaler_GetValueFromArglist( thismod, arglist, 0, resVt, false, Valtype_Func )
			evaler_SetExit thismod, ExitMode_Break, tmp, resVt
			resVt = Valtype_Assoc
			return null					// break ̂͂Ƃ肠 null ԋp
			
		// do( block )
		case Func_Syntax_Do:
			evaler_BeginMode thismod, RunMode_LoopDo
			mNestLoop ++
			
			env_New tmp(0), miEnv		// V𐶐
			tmp(1) = evaler_GetValueFromArglist( thismod, arglist, 0, resVt, false, Valtype_Block )
			
			Stack_push mStkLoop, new_pair( tmp(0), tmp(1) )		// g (env, block) ς
			
			resVt = Valtype_Assoc
			return assocNull			// _~[lX^bNɐς (̂܂ do() ̕ԒlƂ)
			
		// for
		case Func_Syntax_For:
			return evaler_ProcFuncSyntax_For(thismod, iFunc, resVt, arglist, cntArgs)
			
		// !error
		default:
			assert
	swend
	
// for
#modcfunc evaler_ProcFuncSyntax_For int iFunc, var resVt, int arglist, int cntArgs,  \
	local result, local prmlist, local tmp, local tmp_vt, \
	local ident,  local defcnt, local fincnt,  local block, local qBlock,  \
	local iEnvNxt, local iVar
	
	if ( cntArgs != 4 ) { PutError Error_Argc }
	resVt  = Valtype_Assoc
	result = assocNull
	
	// `FbN : ( ident, int, int, block )
	dim prmlist, 4, 2
		prmlist(0, 0) = Valtype_Ident, Valtype_Int, Valtype_Int, Valtype_Block
		prmlist(0, 1) = true,          false,       false,       false
	
	repeat cntArgs
		tmp = evaler_GetValueFromArglist( thismod, arglist, cnt, tmp_vt, prmlist(cnt, 1), prmlist(cnt, 0) )
		if ( stt_error ) { break }
		switch ( cnt )
			xcase 0: ident  = tmp		// JE^ϐ̎ʎq
			xcase 1: defcnt = tmp		// l
			xcase 2: fincnt = tmp		// Il
			xcase 3: block  = tmp		// s
		swend
	loop
	if ( stt_error ) { PutError }
	
	if ( defcnt >= fincnt ) { return result }	// Ɋ
	
	// V̐
	env_New      iEnvNxt, miEnv
	assoc_DefVar env_GetAssoc(iEnvNxt), ident, defcnt, Valtype_Int	// JE^ϐ
	iVar = stat
	
	// loop [hn߂
	tmp = new_unor()
	unor_add tmp, "iEnv",   iEnvNxt
	unor_add tmp, "block",  block
	unor_add tmp, "iVar",   iVar
	unor_add tmp, "fincnt", fincnt
	
	mNestLoop ++
	Stack_push mStkLoop, tmp
	
	evaler_BeginMode thismod, RunMode_LoopFor
	
	resVt = Valtype_Assoc
	return assocNull			// _~[lX^bNɐς (̂܂ for() ̕ԒlƂ)
	
//------------------------------------------------
// gݍ݊֐(Type)
// 
// @in evaler
//------------------------------------------------
#modcfunc evaler_ProcFuncType int thisAssoc, int iFunc, var resVt, int arglist, int cntArgs,  \
	local result, local tmp, local tmp_vt, \
	local prms, local block, \
	local lhs,  local lhs_vt, local rhs, local rhs_vt, \
	local iVar
	
	switch ( iFunc )
		// ident
		case Func_Type_Ident:
			PutError Error_Unsupported
			
		// var(ident)
		case Func_Type_Var:
			if ( cntArgs != 1 ) { PutError Error_Argc }
			switch ( argt(0) )
				case Valtype_Ident:
					tmp    = argv(0)		// ʎq
					result = tmp
					resVt  = Valtype_Ident
					evaler_ExpandIdent thismod, result, resVt,  true, true		// ʎqWJ (true: ȂΒ`, true: ʊȂ)
					assert resVt == Valtype_Var || resVt == Valtype_Propaty
					swbreak
					
				case Valtype_Var:
					resVt = Valtype_Var
					result = argv(0)
					swbreak
					
				default:
					PutError Error_NeedIdent
			swend
			return result
			
		// bool
		case Func_Type_Bool:
			if ( cntArgs != 1 ) { PutError Error_Argc }
			tmp = arg_GetValue(0, tmp_vt)
			
			resVt = Valtype_Bool
			if ( tmp_vt == Valtype_Bool ) {
				return tmp
				
			} elsif ( tmp_vt == Valtype_Assoc ) {
				return evaler_ProcOpUni_AssocCnv( thismod, tmp, resVt, Valtype_Bool )
				
			} else {
				PutErrorMsg "֐ bool  bool, assoc(has ToBool) ^̂ݎ󂯎B"
			}
			
		// int
		// double
		case Func_Type_Int:
		case Func_Type_Double:
			if ( cntArgs != 1 ) { PutError Error_Argc }
			tmp = arg_GetValue(0, tmp_vt)
			
			if ( tmp_vt == Valtype_Assoc ) {		// ^ϊo
				return evaler_ProcOpUni_AssocCnv( thismod, tmp, resVt, TypeFuncToValtype(iFunc) )
			}
			
			if ( not EnumRange_Valtype_Numeric(tmp_vt) ) {
				PutErrorMsg "֐ " + Func_GetName(iFunc) + "  int, double, complex, assoc ^̂ݎ󂯎B"
			}
			
			if ( iFunc == Func_Type_Int ) {
				resVt = Valtype_Int    : return int( tmp )
			} else {
				resVt = Valtype_Double : return double( tmp )
			}
			
		// string
		case Func_Type_String:
			if ( cntArgs != 1 ) { PutError Error_Argc }
			tmp = arg_GetValue(0, tmp_vt)
			
			resVt = Valtype_String
			switch ( tmp_vt )
				case Valtype_Bool:
				case Valtype_Int: 
				case Valtype_Double:
					return DecodeEvalElem(tmp_vt, tmp)
					
				case Valtype_String:
					return tmp
					
				case Valtype_Assoc:
					return evaler_ProcOpUni_AssocCnv( thismod, tmp, resVt, Valtype_String )
					
			;	case Valtype_Block:
			;	case Valtype_Func:
			;	case Valtype_Method
			;	case Valtype_Propaty:
				default:
					PutErrorMsg GetName_Valtype( tmp_vt ) + " ^̒l string ɕϊłȂB"
			swend
			
		// assoc( pair... )
		// class( pair... )
		case Func_Type_Assoc:
		case Func_Type_Class:
			result = new_assoc(miEnv)		// Aẑ𐶐
			resVt  = Valtype_Assoc
			
			repeat cntArgs
				tmp = evaler_GetValueFromArglist( thismod, arglist, cnt, tmp_vt, true )	// EӒlWJȂ
				if ( stt_error ) { break }
				if ( IsOmission(tmp, tmp_vt) ) { continue }						// ȗ𖳎
				
				if or( tmp_vt != Valtype_Assoc, tmp == assocNull, assoc_GetPrototypeAssoc(tmp) != stt_assoc_pair ) {
					PutErrorImpl Error_NeedPair : break		//  (AẑłȂ || null || (:)łȂ)
				}
				
				lhs = var_GetValue( assoc_Find(tmp, "lhs"), lhs_vt )
				rhs = var_GetValue( assoc_Find(tmp, "rhs"), rhs_vt )
				if ( lhs_vt != Valtype_Ident ) { PutErrorImpl Error_NeedIdent : break }
				
				assoc_DefVar result, (lhs), rhs, rhs_vt		// Aẑɒǉ
			loop
			if ( stt_error ) { PutError }
			
			return result
			
		// block  l݂̂琬鎮
		case Func_Type_Block:
			if ( cntArgs != 1 ) { PutError Error_Argc }
			tmp = arg_GetValue(0, tmp_vt)			// EӒlWJς
			resVt = Valtype_Block
			return new_block_byValue( tmp, tmp_vt, miEnv )
			
		// func(prms...) { block }
		case Func_Type_Func:
			if ( cntArgs == 0 ) { PutError Error_Argc }
			
			// Xg
			repeat cntArgs - 1
				if ( argt(cnt) != Valtype_Ident ) { PutErrorImpl Error_NeedIdent : break }
				prms(cnt) = argv(cnt)
			loop
			if ( stt_error ) { PutError }
			
			//  (ŏI)
			block = evaler_GetValueFromArglist( thismod, arglist, (cntArgs - 1), tmp_vt, false, Valtype_Block )
			if ( stt_error ) { PutError }
			
			// ֐̐
			StrCalc_DefFunc miEnv, "", (cntArgs - 1) : result = stat
			func_SetBlock   result, block
			func_SetPrmlist result, prms
			
			// ԋp
			resVt = Valtype_Func
			return FuncValue( PlugIn_Userdef, result )
			
		// method(prms...) { block }
		// @  ʎq(this) ǉ func ɈϏ
		case Func_Type_Method:
			tmp = vector_Slice(arglist)
			vector_PushFront tmp, "this", Valtype_Ident
			return evaler_ProcFuncType( thismod, assocNull, Func_Type_Func, resVt, tmp, (cntArgs + 1) )
			
		// propaty
		// @  assoc() Ɋۓ
		case Func_Type_Propaty:
			tmp(0) = assocNull		//  this-assoc  null Ƃ
			tmp(1) = evaler_ProcFuncType( thismod, assocNull, Func_Type_Assoc, resVt, arglist, cntArgs )
			
			resVt = Valtype_Propaty
			return new_pair( tmp(0), tmp(1) )		// pair of (this-assoc, propaty-assoc)
			
		// ref( ident|var|propaty )
		case Func_Type_RefArg:
			if ( cntArgs != 1 ) { PutError Error_Argc }
			tmp = arg_GetValue(0, tmp_vt)
			resVt = Valtype_RefArg
			
			switch ( tmp_vt )
				case Valtype_RefArg:
					return tmp
					
				case Valtype_Var:
				case Valtype_Propaty:
					return new_pair( tmp, tmp_vt )
					
				case Valtype_Ident:
					evaler_ExpandIdent thismod, tmp, tmp_vt
					go_case tmp_vt
					
				default:
					PutError Error_NeedLeftValue
			swend
			
		// vector( values... )
		// tuple
		case Func_Type_Vector:
		case Func_Type_Tuple:
			resVt = Valtype_Assoc
			if ( arglist == assocNull ) { return new_vector(miEnv) }	// null =>  vector ԋp
			result = vector_Dup( arglist )
			if ( iFunc == Func_Type_Tuple ) { vector_BeTuple result : evaler_ExpandAssoc thismod, result, resVt }
			return result
			
		// pair( values... )
		case Func_Type_Pair:
			if ( cntArgs != 2 ) { PutError Error_Argc }
			
			lhs = arg_GetValue(0, lhs_vt)
			rhs = arg_GetValue(1, rhs_vt)
			
			return evaler_ProcOpBin_Pair( thismod, BinOp_Pair, resVt, lhs, lhs_vt, rhs, rhs_vt )
			
		// complex
		case Func_Type_Complex:
			if ( cntArgs != 1 ) { PutError Error_Argc }
			tmp = arg_GetValue(0, tmp_vt)
			
			if ( tmp_vt == Valtype_Assoc ) {		// ^ϊo
				if ( IsComplex(tmp, tmp_vt) ) { resVt = Valtype_Assoc : return tmp }
				PutErrorMsg "Az̉Z ." + CnvFuncName("Complex") + " ͖̏B"
			}
			
			if ( not EnumRange_Valtype_Numeric(tmp_vt) ) {
				PutErrorMsg "֐ " + Func_GetName(iFunc) + "  int, double, complex ^̂ݎ󂯎B"
			}
			
			resVt = Valtype_Assoc
			return new_complex_real( tmp, miEnv )
			
		default: assert
	swend
	
	return
	
//------------------------------------------------
// gݍ݊֐(Operation)
// 
// @in evaler
// @ ZX^bN𑀍삷
//------------------------------------------------
#modcfunc evaler_ProcFuncOperation int thisAssoc, int iFunc, var resVt, int arglist, int cntArgs,  \
	local optype, \
	local tmp, local tmp_vt
	
	assert( thisAssoc == assocNull )
	optype = OperateFuncToOptype(iFunc)		// ֐ID  ZqID
	
	// PZ
	if ( optype < PostfixOp_Max ) {
		// XgZ
		// @  (called-object, args...)
		if ( EnumRange_UniOp_List( optype ) ) {
			if ( cntArgs == 0 ) { PutError Error_Argc }		// (called-object)͕K{
			tmp = vector_Slice( arglist, 1 )				// ̈ȊÖXg
			PushToStack mStkCalc, argv(0), argt(0)
			PushToStack mStkCalc, tmp, Valtype_Arglist
			
		// PZ
		} else {
			if ( cntArgs != 1 ) { PutError Error_Argc }
			PushToStack mStkCalc, argv(0), argt(0)
		}
		
		return evaler_CallOpUni(thismod, optype, resVt)		// PZ / XgZ
		
	// 񍀉Z
	} else {
		if ( cntArgs != 2 ) { PutError Error_Argc }
		tmp = arg_GetValue( 0, tmp_vt )
		PushToStack mStkCalc, tmp, tmp_vt		// lhs
		
		tmp = arg_GetValue( 1, tmp_vt )
		PushToStack mStkCalc, tmp, tmp_vt		// rhs
		
		// ZZ̃G[`FbN
		;{
			// ?:  then-, else- Z (rhs ΂̂Ƃ)
			if and( optype == BinOp_Which, tmp_vt == Valtype_Assoc, assoc_GetPrototypeAssoc(tmp) == stt_assoc_pair ) {
				
				// lhs, rhs Ɏ򉻂
				if ( var_GetType(assoc_Find(tmp, "lhs")) != Valtype_Block || var_GetType(assoc_Find(tmp, "rhs")) == Valtype_Block ) {
					PutErrorMsg "opWhich() ̉Eӂ(pair)łꍇA lhs, rhs ɂ͗p鎮̎򂪕KvB\n() a ? b : c  opWhich( a, { b } : { c } )"
				}
				
			// rhs-Z
			} elsif ( IsShortCircuitRhs(optype) ) {
				if ( tmp_vt != Valtype_Block ) { PutErrorMsg "rhs-Z Zq̉Z֐ĂԏꍇAEӂɂ͗p鎮̎򂪕KvB\n() (a " + DecodeOp_Bin(optype) + " b)  " + OpFuncName(GetName_BinOp(optype)) + "( a, { b } )" }
			}
		;}
		
		
		return evaler_CallOpBin(thismod, optype, resVt)		// 񍀉Z
	}
	
//------------------------------------------------
// gݍ݊֐(Math)
//------------------------------------------------
#defcfunc StrCalc_ProcFuncMath int thisAssoc, int iFunc, var resVt, int arglist, int cntArgs, int iEnv,  \
	local result, local arg_vt, local bComplex, local tmp
	
	resVt = Valtype_Double		// b
	
	dim bComplex, 4
	
	// `FbN
	repeat cntArgs
		arg_vt(cnt)   = argt(cnt)
		bComplex(cnt) = IsComplex( argv(cnt), arg_vt(cnt) )
		if not( arg_vt(cnt) == Valtype_Int || arg_vt(cnt) == Valtype_Double || bComplex(cnt) ) {
			PutErrorMsgImpl "Math vOC֐͎Zp^̂ݎ󂯎B" : break
		}
	loop
	if ( stt_error ) { PutError }
	
	switch ( iFunc )
		case Func_Math_Zero:
			resVt = Valtype_Int
			return 0
			
		// Βl
		case Func_Math_Abs:
			switch ( argt(0) )
				case Valtype_Int:    resVt = Valtype_Int    : return abs ( argv(0) )
				case Valtype_Double: resVt = Valtype_Double : return absf( argv(0) )
				case Valtype_Assoc:  return complex_sizeValue( argv(0), resVt )
			swend
			
		//  / Pʕf
		case Func_Math_Sgn:
			if ( bComplex(0) ) {			// f => K
				resVt = Valtype_Assoc
				return new_complex_unit( complex_arg( argv(0) ), iEnv )
			} else {
				resVt = Valtype_Int
				return sgn( argv(0) )
			}
			
		// ۂߍ
		case_if (  Func_Math_Round <= swthis && swthis <= Func_Math_Ceil ):
			if ( bComplex(0) ) { PutErrorNeed(Valtype_Double) }
			resVt = Valtype_Int
			switch ( iFunc )
				case Func_Math_Round: return round( argv(0) )
				case Func_Math_Floor: return floor( argv(0) )
				case Func_Math_Ceil:  return  ceil( argv(0) )
			swend
			
		// ϒZ
		case Func_Math_Add:
		case Func_Math_Average:
		case Func_Math_Mul:
			resVt  = Valtype_Int
			result = which( swthis == Func_Math_Mul, 1, 0 )		// l
			
			repeat cntArgs
				tmp    = argv(cnt)
				result = evaler_ProcOpBin_Arith( stt_simple_evaler, which( iFunc == Func_Math_Mul, BinOp_Mul, BinOp_Add ), resVt, result, resVt, tmp, arg_vt(cnt) )
			loop
			
			if ( iFunc == Func_Math_Average ) {		// 
				if ( resVt == Valtype_Assoc ) {
					complex_MulWithReal result, 1.0 / cntArgs
				} else {
					result /= cntArgs
				}
			}
			
			StrCalc_ArithCnvDown result, resVt
			return result
			
		// 
		case Func_Math_Gcd: resVt = Valtype_Int : return gcd_i( int(argv(0)), int(argv(1)) )
		case Func_Math_Lcm: resVt = Valtype_Int : return lcm_i( int(argv(0)), int(argv(1)) )
		
		case Func_Math_Maxf:
		case Func_Math_Minf:
			if ( cntArgs == 0 ) { PutError Error_Argc }
			
			result = argv(0)
			repeat cntArgs - 1, 1
				if ( bComplex(0) ) { PutErrorImpl Error_NeedDouble }
				
				result = which( (iFunc == Func_Math_Maxf), max_f(result, argv(cnt)), min_f(result, argv(cnt)) )
			loop
			if ( stt_error ) { PutError }
			
			StrCalc_ArithCnvDown result, resVt
			return result
			
		// ꍇ̐
		case_if ( Func_Math_Permutation <= swthis && swthis <= Func_Math_CRepeated ):
			if ( cntArgs != 2 ) { PutError Error_Argc }
			if ( bComplex(0) || bComplex(1) ) { PutErrorNeed(Valtype_Int) }
			resVt = Valtype_Double
			switch ( iFunc )
				case Func_Math_Permutation: return permutation( int(argv(0)), int(argv(1)) )
				case Func_Math_Combination: return combination( int(argv(0)), int(argv(1)), false )
				case Func_Math_CRepeated:   return combination( int(argv(0)), int(argv(1)), true  )
			swend
			
		// Z
		case Func_Math_Pow:
		case Func_Math_Log:
		case Func_Math_Root:
			if ( cntArgs != 2 ) { PutError Error_Argc }
			result = argv(0)	// 
			tmp    = argv(1)	// E
			
			if ( bComplex(0) || bComplex(1) ) {
				StrCalc_ArithCnv result, arg_vt(0), tmp, arg_vt(1)
				if ( bComplex(0) ) {
					result = complex_Dup(result)	// Ԓlpɕ
				}
				
				resVt = Valtype_Assoc
				switch ( iFunc )
					xcase Func_Math_Pow:  complex_Pow  result, tmp
					xcase Func_Math_Log:  complex_Log  result, tmp
					xcase Func_Math_Root: complex_Root result, tmp
				swend
			} else {
				resVt = Valtype_Double
				switch ( iFunc )
					xcase Func_Math_Pow:  result = evaler_ProcOpBin_Arith_PowReal ( stt_simple_evaler, resVt, result, arg_vt(0), tmp, arg_vt(1) )
					xcase Func_Math_Log:  result = evaler_ProcOpBin_Arith_LogReal ( stt_simple_evaler, resVt, result, arg_vt(0), tmp, arg_vt(1) )
					xcase Func_Math_Root: result = evaler_ProcOpBin_Arith_RootReal( stt_simple_evaler, resVt, result, arg_vt(0), tmp, arg_vt(1) )
				swend
			}
			StrCalc_ArithCnvDown result, resVt
			return result
			
		case Func_Math_Exp:
		case Func_Math_Ln:
		case Func_Math_Log10:
		case Func_Math_Sqrt:
			if ( cntArgs != 1 ) { PutError Error_Argc }
			if ( bComplex(0) ) {
				result = complex_Dup( argv(0) )
				resVt  = Valtype_Assoc
				switch ( iFunc )
					xcase Func_Math_Exp:   complex_Exp result
					xcase Func_Math_Ln:    complex_Ln          result
					xcase Func_Math_Log10: complex_LogWithReal result, 10
					xcase Func_Math_Sqrt:  complex_Sqrt result
				swend
			} else {
				resVt = Valtype_Double
				switch ( iFunc )
					xcase Func_Math_Exp:   result = expf( argv(0) )
					xcase Func_Math_Ln:    result = evaler_ProcOpUni_Arith_LnReal  ( stt_simple_evaler, resVt, argv(0) )
					xcase Func_Math_Log10: result = evaler_ProcOpUni_Arith_LnReal  ( stt_simple_evaler, resVt, argv(0) ) / M_LN10
					xcase Func_Math_Sqrt:  result = evaler_ProcOpUni_Arith_SqrtReal( stt_simple_evaler, resVt, argv(0) )
				swend
			}
			StrCalc_ArithCnvDown result, resVt
			return result
			
		/*
		case Func_Math_Pow:   return powf( argv(0), argv(1) )
		case Func_Math_Exp:   return expf( argv(0) )
		case Func_Math_Log:   return logf( argv(1) ) / logf( argv(0) )
		case Func_Math_Ln:    return logf( argv(0) )
		case Func_Math_Log10: return logf( argv(0) ) / M_LN10
		case Func_Math_Root:  return root( argv(0), argv(1) )
		case Func_Math_Sqrt:  return sqrt( argv(0) )
		//*/
		case Func_Math_Sin:
		case Func_Math_Cos:
		case Func_Math_Tan:
			if ( cntArgs != 1 ) { PutError Error_Argc }
			if ( bComplex(0) ) {
				result = complex_Dup( argv(0) )
				resVt  = Valtype_Assoc
				switch ( iFunc )
					xcase Func_Math_Sin: complex_sin result
					xcase Func_Math_Cos: complex_cos result
					xcase Func_Math_Tan: complex_tan result
				swend
			} else {
				resVt = Valtype_Double
				switch ( iFunc )
					xcase Func_Math_Sin: return sin( argv(0) )
					xcase Func_Math_Cos: return cos( argv(0) )
					xcase Func_Math_Tan: return tan( argv(0) )
				swend
			}
			StrCalc_ArithCnvDown result, resVt
			return result
			
		/*
		case Func_Math_Sin: return sin( argv(0) )
		case Func_Math_Cos: return cos( argv(0) )
		case Func_Math_Tan: return tan( argv(0) )
		//*/
		case Func_Math_Atan:
			if ( bComplex(0) ) { PutErrorNeed(Valtype_Double) }
			return argof( argv(0), which( cntArgs == 1, 1.0, sgn(argv(1)) ) )
		
		// 
		case Func_Math_Randomize:
			if ( cntArgs != 1 ) { PutError Error_Argc }
			if ( bComplex(0) ) { PutErrorNeed(Valtype_Int) }
			
			rndf_ini argv(0)		// 
			resVt = Valtype_Assoc
			return assocNull		// nullԋp
			
		case Func_Math_Rnd:
			if ( cntArgs == 0 ) {
				rndf_get result		//  [0, 1) ̘A
				
			} else {
				if ( cntArgs > 2 ) { PutError Error_Argc }
				if ( bComplex(0) || bComplex(1) ) { PutErrorNeed(Valtype_Int) }
				
				if ( argt(0) == Valtype_Int ) {
					resVt = Valtype_Int
					if ( cntArgs == 1 ) { rndf_geti result, argv(0) }										//  [0, max)   ̐
					else                { rndf_geti result, (int(argv(1)) - argv(0)) : result += argv(0) }	//  [lhs, rhs) ̐
				} else {
					rndf_get result
					if ( cntArgs == 1 ) { result *= argv(0)  }											//  [0, max)   ̎
					else                { result  = (double(argv(1)) - argv(0)) * result + argv(0) }	//  [lhs, rhs) ̎
				}
			}
			return result
		default:
			assert
	swend
	
//**********************************************************
//        [U`֐̎s
//**********************************************************
//------------------------------------------------
// [U`֐(Userdef)
//------------------------------------------------
#modcfunc evaler_ProcFuncUserdef int thisAssoc, int iFunc, var resVt, int arglist, int cntArgs,  local cntPrms
	
	cntPrms = func_GetCntPrms( iFunc )
	
	if ( cntPrms > 0 && cntPrms != cntArgs ) {
		logmes strf("[Warning] when vZ::֐̎s\nُ̐\n֐\t: %s\n\t: %d\n\t: %d", func_GetName( iFunc ), cntPrms, cntArgs )
	}
	
	// evaler_ProcFuncUserdefImpl ĂѕԂĂ炤
	return func_Call( iFunc, thismod, resVt, thisAssoc, arglist )
	
//------------------------------------------------
// [U`֐(Userdef)
//------------------------------------------------
#modcfunc evaler_ProcFuncUserdefImpl int thisAssoc, int iFunc, array exprQueue, int arglist, var prmlist, var resVt, int iEnv,  \
	local result, local cntArgs, local iEnvNxt, local evaler
	
	// V𐶐
	env_New iEnvNxt, iEnv			// ̒
	if ( thisAssoc != assocNull ) {
		env_SetThis iEnvNxt, thisAssoc
	}
	
	// VɎ
	StrCalc_ProcFuncUserdef_DefArgs iEnvNxt, arglist, prmlist
	
	// evaler p
	func_GetEvaler iFunc, evaler, iEnvNxt
	
	// s
	evaler_Run evaler
	
	result = evaler_InheritExit( thismod, evaler, resVt )
	if or( mExitMode == ExitMode_Return, and( mExitMode == ExitMode_Break, mExitVt == Valtype_Func, FuncId(mExitValue) == iFunc ) ) {
		evaler_RemoveExit thismod
	}
	
	return result
	
//------------------------------------------------
// Vɐ
// 
// @ 1. ϐ arguments (<: Vector) `B
// @ 2. () XgǏϐɒ`B
// @	葽́Anull ԂŒ`B
//------------------------------------------------
#deffunc StrCalc_ProcFuncUserdef_DefArgs int iEnv, int arglist, var prmlist,  \
	local cntArgs, local cntPrms, local iVar, local tmp_vt, local arguments
	
	cntArgs = vector_Size(arglist)
	
	// arglist ϐ arguments ƂĐVɔzu
	assoc_DefVar env_GetAssoc(iEnv), "arguments", arglist, Valtype_Assoc
	
	// GCAX𐶐
	if ( prmlist != listNull ) {
		cntPrms = list_size(prmlist)
		repeat limit( cntArgs, 0, cntPrms )		// min(cntArgs, cntPrms)
			assoc_ImportVar env_GetAssoc(iEnv), list_get(prmlist, cnt), vector_Get(arglist, cnt)
		loop
		
		// ȗꂽ null Ē`
		if ( cntPrms > cntArgs ) {
			repeat cntPrms - cntArgs, cntArgs
				assoc_DefVar env_GetAssoc(iEnv), list_get(prmlist, cnt), assocNull, Valtype_Assoc
			loop
		}
	}
	
	return
	
//------------------------------------------------
// ֐
// 
// @result: valFunc  arglist 𑩔֐
//------------------------------------------------
#defcfunc StrCalc_BindFunc int valFunc, int arglist, int iEnv,  \
	local iFunc, local iPlugin, \
	local cntPrms, local cntArgs, local iFuncNew, \
	local tmp, local tmp_vt
	
	iPlugin = PluginId(valFunc)
	iFunc   = FuncId(valFunc)
	
	cntPrms = func_GetCntPrms(iFunc)
	cntArgs = vector_Size(arglist)
	
	if and( cntPrms >= 0, cntPrms < cntArgs ) { PutError Error_Argc }	
	
	// ֐̐
	StrCalc_DefFunc iEnv, "", cntPrms - cntArgs : iFuncNew = stat
	func_Bind iFuncNew, iFunc, arglist
	
	// ԋp
	return FuncValue( iPlugin, iFuncNew )
	
// \bḧ
#defcfunc StrCalc_BindMethod int self, int arglist, int iEnv,  \
	local result
	
	result = new_pair()
	pair_setLhs result, pair_getLhs(self) 
	pair_setRhs result, StrCalc_BindFunc( pair_getRhs(self), arglist, iEnv )
	return result
	
//**********************************************************
//        
//**********************************************************
//------------------------------------------------
// ̎s
//------------------------------------------------
#modcfunc evaler_ProcBlock int thisAssoc, int block, var resVt,  local iEnvNxt, local q
	
	// V
	env_New iEnvNxt, block_GetEnv(block)	// ̒
	if ( thisAssoc != assocNull ) {
		env_SetThis iEnvNxt, thisAssoc
	}
	
	// s
	return evaler_ProcBlockHere( thismod, block, resVt, iEnvNxt )
	
#modcfunc evaler_ProcBlockHere int block, var resVt, int iEnv,  local evaler, local result
	evaler_New evaler, block, iEnv
	evaler_Run evaler
	return evaler_InheritExit( thismod, evaler, resVt )
	
// (exit-mode pȂ)
#defcfunc StrCalc_ProcBlock int thisAssoc, int block, var resVt,  local iEnvNxt
	
	// V
	env_New iEnvNxt, block_GetEnv(block)	// ̒
	if ( thisAssoc != assocNull ) {
		env_SetThis iEnvNxt, thisAssoc
	}
	return StrCalc_ProcBlockHere( block, resVt, iEnvNxt )
	
#defcfunc StrCalc_ProcBlockHere int block, var resVt, int iEnv,  local evaler
	evaler_New evaler, block, iEnv
	evaler_Run evaler
	return evaler_Get( evaler, resVt )
	
//------------------------------------------------
// ̓ꉻ
//------------------------------------------------
#modcfunc StrCalc_SpecializeBlock int arglist, var resVt, int thisAssoc, int src,  \
	local cntArgs, local block, local ptnSrc, local ptnDst, local q, local bByValue, \
	local lhs_var, local lhs, local lhs_vt, \
	local rhs_var, local rhs, local rhs_vt
	
	block   = src			// ^()
	cntArgs = vector_Size(arglist)
	
	if ( cntArgs > 0 ) {
		ptnSrc = new_queue(), new_queue()
		ptnDst = new_queue(), new_queue()
		
		// XgŎꉻ
		repeat cntArgs
			if ( list_empty(block_GetIdentlist(block)) ) { break }	// `ʎqȂ => ꉻ̏I
			
			// ΂ł̓ꉻ or ꉻ
			bByValue = ( argt(cnt) != Valtype_Assoc )
			if ( bByValue == false ) {
				lhs_var  = assoc_Find(argv(cnt), "lhs")
				rhs_var  = assoc_Find(argv(cnt), "rhs")
				bByValue = ( lhs_var < 0 || rhs_var < 0 )
			}
			
			// ΂ł̓ꉻ
			if ( bByValue == false ) {
				lhs = var_GetValue( lhs_var, lhs_vt )
				rhs = var_GetValue( rhs_var, rhs_vt )
		;		logmes dbgpair(lhs, lhs_vt)
		;		logmes dbgpair(rhs, rhs_vt)
				
				if ( lhs_vt != Valtype_Ident && lhs_vt != Valtype_Block ) {
					logmes "[Error] when ̓ꉻ\n #" + cnt + " ̍(lhs)ʎqłłȂB"
					stt_error = Error_NeedIdent : assert
					break
				}
				
			// ꉻ
			} else {
				// : ڂ̖`ʎq
				lhs    = list_get( block_GetIdentlist(block), 0 )
				lhs_vt = Valtype_Ident
				
				// E: l
				rhs    = argv(cnt)
				rhs_vt = argt(cnt)
				evaler_ExpandValueAsRVal thismod, rhs, rhs_vt
			}
			
			// ꉻ
			repeat 2 : Queue_clear ptnSrc(cnt) : Queue_clear ptnDst(cnt) : loop
			
			if ( lhs_vt == Valtype_Block ) { block_GetQueue lhs, ptnSrc } else { PushToQueue ptnSrc, lhs, lhs_vt }
			if ( rhs_vt == Valtype_Block ) { block_GetQueue rhs, ptnDst } else { PushToQueue ptnDst, rhs, rhs_vt }
			
			block = block_ReplaceDerive( block, ptnSrc, ptnDst )
		loop
		if ( stt_error ) { return failure }
	}
	
	return block
	
//**********************************************************
//        ⏕֐
//**********************************************************
//------------------------------------------------
// Xg̒l̎o
//------------------------------------------------
#modcfunc evaler_GetValueFromArglist int arglist, int idx, var resVt, int bNoExpandAsRVal, int valtype, int bCanDefault,  local result
	
	if ( vector_Size(arglist) <= idx ) {		// s
		if ( bCanDefault ) { resVt = Valtype_Mark : return TkType_Omission }
		PutError Error_NoDefault
	}
	
	result = arg_GetValue( idx, resVt )
	
	if ( bNoExpandAsRVal == false ) {
		evaler_ExpandValueAsRVal thismod, result, resVt
	}
	
	// ^`FbN
	if ( valtype != Valtype_Error ) {
		if ( IsOmission(result, resVt) ) {
			if ( not bCanDefault ) { PutError Error_NoDefault }
		} elsif ( resVt != valtype ) {
			dbgout dbgpair(idx, resVt)
			PutErrorNeed(valtype)
		}
	}
	
	return result
	
#undef argv
#undef argt
