// Klac - enum valtype

#ifndef IG_KLAC_ENUM_VALTYPE_AS
#define IG_KLAC_ENUM_VALTYPE_AS

//------------------------------------------------
// l̃^Cv
// 
// @synchronizing:
// @	Valtype [_Error, _Mark)
// @	Error   [_NeedValtype, _NeedValtype_Max]
//------------------------------------------------
#enum Valtype_Error = 0
#enum Valtype_Ident
#enum Valtype_Var
#enum Valtype_Bool
#enum Valtype_Int
#enum Valtype_Double
#enum Valtype_String
#enum Valtype_Assoc
#enum Valtype_Block
#enum Valtype_Func
#enum Valtype_Method
#enum Valtype_Propaty

// inner
#enum Valtype_RefArg
#enum Valtype_Arglist

// for Proc
#enum Valtype_Mark
#enum Valtype_OpUni
#enum Valtype_OpBin
#enum Valtype_OpPoly
#enum Valtype_Omission

// for Decode
#enum Valtype_Decoded

#enum Valtype_Max

// ͈
#define ctype EnumRange_Valtype_Numeric(%1)    ((%1) == Valtype_Int || (%1) == Valtype_Double)
#define ctype EnumRange_Valtype_Assignable(%1) ((%1) == Valtype_Ident || (%1) == Valtype_Var || (%1) == Valtype_Propaty)
#define ctype EnumRange_Valtype_Callable(%1)   (Valtype_Assoc  <= (%1) && (%1) <= Valtype_Method)
#define ctype EnumRange_Valtype_Indexable(%1)  (Valtype_String <= (%1) && (%1) <= Valtype_Method)

#endif
