// StrCalc - MCEnvImpl

#ifndef IG_STRCALC_MODULECLASS_ENV_IMPL_AS
#define IG_STRCALC_MODULECLASS_ENV_IMPL_AS

#include "Mo/abdata/mod_pvalptr.as"
#include "Mo/abdata/list.as"
#include "Mo/abdata/pair.as"

#include "MCAssoc.as"
#include "MCPlugin.as"
#include "MCVar.as"

#module MCEnvImpl miThis, mUpper, mlcAssoc, mUsing, mbGlobal

#include "enum_valtype.as"

#define VAR_TEMP _stt_temp@MCEnvImpl
	dim VAR_TEMP

//##########################################################
//                \zE
//##########################################################
#define global envImplGlobal_New(%1) newmod %1, MCEnvImpl@, stt_zero@, true
#define global envImpl_New(%1, %2)   newmod %1, MCEnvImpl@, %2, false

//------------------------------------------------
// \z
// 
// @ local => ̃XR[vւ̃NB
//------------------------------------------------
#modinit var upperEnv, int bGlobal
	miThis   = getaptr(thismod)
	mbGlobal = bGlobal
	mlcAssoc = new_assoc_local( miThis )	// ǏAz  [Jϐ̘Az
	
	mUsing   = new_list()
	
	// init
	if ( bGlobal ) {
		//
	} else {
		mUpper = upperEnv
	}
	
	return miThis
	
//##########################################################
//                
//##########################################################
dim stt_lastFoundAssoc

//------------------------------------------------
// ǏAẑ̕ϐ̕ϐT
// 
// @prm bNoChain : ʊTȂB
// @return: iVar or (-1)
//------------------------------------------------
#modcfunc envImpl_FindVar str name, int bNoChain, local idx
	
	// T
	idx = assoc_Find( mlcAssoc, name )
	
	if ( idx >= 0 ) { stt_lastFoundAssoc = mlcAssoc : return idx }
	
	// using AẑT
	repeat list_size(mUsing)
		idx = assoc_Find( list_get(mUsing, cnt), name )		// Az̓̕ϐ
		if ( idx >= 0 ) { stt_lastFoundAssoc = list_get(mUsing, cnt) : break }
	loop
	
	if ( idx >= 0 ) { return idx }
	if ( mbGlobal || bNoChain ) { return -1 }	// ł
	
	// ʊT (XR[v`F[H)
	return envImpl_FindVar( mUpper, name )
	
// FindVar ōŌɃqbgAz
#defcfunc env_LastFoundAssoc
	return stt_lastFoundAssoc
	
//##########################################################
//                o
//##########################################################
//------------------------------------------------
// ǏAz(lcAssoc)擾
//------------------------------------------------
#modcfunc envImpl_GetAssoc
	return mlcAssoc
	
//------------------------------------------------
// Az(this-assoc)ݒE擾
// 
// @result: assoc value, or -1 (failure)
//------------------------------------------------
#modcfunc envImpl_GetThis  local iVar
	iVar = envImpl_FindVar( thismod, "this" )
	
	if ( iVar < 0 ) { return -1 }
	if ( var_GetType(iVar) != Valtype_Assoc ) {
		return -1
	}
	
	return var_Get(iVar)
	
#modfunc envImpl_SetThis int this_assoc
	assoc_DefVar mlcAssoc, "this", this_assoc, Valtype_Assoc
	return
	
//------------------------------------------------
// using
//------------------------------------------------
#modfunc envImpl_Using int iAssoc
	list_add mUsing, iAssoc
	return
	
//##########################################################
//                `
//##########################################################

#global

#endif
