// Klac - partial: call op

// #partial MCEvaler

// @ X^bN̉Zo(PopAs_)ƁAZ{(evaler_ProcOp**)̌ĂяoB
// @ Z{̂ MCEvaler_proc_op.as ɕB

//##########################################################
//            ZĂяo
//##########################################################
//------------------------------------------------
// PZ::Ăяo
//------------------------------------------------
#modcfunc evaler_CallOpUni int optype, var resVt,  \
	local lhs, local lhs_vt, \
	local tmp
	
	// XgZ : ́uXgZvŏڍ
	if ( EnumRange_UniOp_List(optype) ) {
		return evaler_CallOpUni_ListWrap( thismod, optype, resVt )
	}
	
	// 
	if ( optype == PrefixOp_Inc || optype == PrefixOp_Dec || optype == PostfixOp_Inc || optype == PostfixOp_Dec ) {
		
		// val ӒlƂĎo
		lhs = evaler_PopAsLVal( thismod, lhs_vt )
		
		// 򉉎Z
		if ( lhs_vt == Valtype_Block ) { goto *LProcOpUni_Block }
		
		tmp = evaler_ProcOpUni_Assign( thismod, optype, resVt, lhs, lhs_vt )
		
		if ( EnumRange_UniOp_Prefix(optype) ) {		// prefix => ̂܂ܕԂ, postfix => u̒lvԂ
			resVt = lhs_vt
			return lhs
		} else {
		;	resVt = tmp_vt
			return tmp
		}
	}
	
	if ( optype == PostfixOp_Tuple ) {
		lhs = evaler_PopAsImpl( thismod, lhs_vt )	// WJ
		return evaler_ProcOpUni_TupleMake( thismod, optype, resVt, lhs, lhs_vt )
	}
	
	// val EӒlƂĎo
	lhs = evaler_PopAsRVal( thismod, lhs_vt )
	
	switch ( optype )
		// lZ
		case_if ( IsTuple(lhs, lhs_vt) ):
			return evaler_ProcOpUni_Tuple( thismod, lhs, resVt, optype )
			
		// Az̉Z
		case_if ( lhs_vt == Valtype_Assoc ):
			return evaler_ProcOpUni_Assoc( thismod, lhs, resVt, optype )
			
		// ֐(=>)
		case PrefixOp_Func:
			return evaler_ProcOpUni_Func( thismod, optype, resVt, lhs, lhs_vt )
			
		// 򉉎Z
		case_if ( lhs_vt == Valtype_Block ):
		:*LProcOpUni_Block
			return evaler_ProcOpUni_Block( thismod, optype, resVt, lhs, lhs_vt )
			
		// _
		case PrefixOp_Neg:
			return evaler_ProcOpUni_Log( thismod, optype, resVt, lhs, lhs_vt )
			
		// Zp
		default:
			return evaler_ProcOpUni_Arith( thismod, optype, resVt, lhs, lhs_vt )
	swend
	
//**********************************************************
//        񍀉Z
//**********************************************************
//------------------------------------------------
// 񍀉Z::Ăяo
//------------------------------------------------
#modcfunc evaler_CallOpBin int optype, var resVt,  \
	local lhs, local lhs_vt, \
	local rhs, local rhs_vt
	
	// [A] ̈ȉZ
	switch ( optype )
		// ؂ ';' => ӂ̂Ă邾̏
		case BinOp_Split:
			rhs = evaler_PopAsImpl( thismod, rhs_vt )
			lhs = evaler_PopAsImpl( thismod, lhs_vt )
			resVt = rhs_vt
			return rhs
			
		// Az '.' or Az '->'
		case BinOp_Assoc:
		case BinOp_AssocBind:
			rhs = evaler_PopAsImpl( thismod, rhs_vt )
			lhs = evaler_PopAsRVal( thismod, lhs_vt )
			return evaler_ProcOpBin_AssocOrAssocBind( thismod, optype, resVt, lhs, lhs_vt, rhs, rhs_vt )
			
		// l ','
		case BinOp_Tuple:
			rhs = evaler_PopAsImpl( thismod, rhs_vt )		// ӂƂœWJ
			lhs = evaler_PopAsImpl( thismod, lhs_vt )		// 
			return evaler_ProcOpBin_Tuple( thismod, resVt, lhs, lhs_vt, rhs, rhs_vt )
			
		// ϊ '+>'
		case BinOp_Trans:
			rhs = evaler_PopAsImpl( thismod, rhs_vt )		// EӂÊǂƂĈ́ACallFunc() ߂
			lhs = evaler_PopAsRVal( thismod, lhs_vt )		//  (ϊ̎) ͉EӒlƂĎo
			return evaler_ProcOpBin_Trans( thismod, resVt, lhs, lhs_vt, rhs, rhs_vt )
			
		//  '<->'
		case BinOp_Swap:
			rhs = evaler_PopAsLVal( thismod, rhs_vt )
			lhs = evaler_PopAsLVal( thismod, lhs_vt )
			
			if ( lhs_vt == Valtype_Block || rhs_vt == Valtype_Block ) {		// 򉉎Z
				return evaler_ProcOpBin_Block( thismod, BinOp_Swap, resVt, lhs, lhs_vt, rhs, rhs_vt )
			}
			
			return evaler_ProcOpBin_Swap( thismod, resVt, lhs, lhs_vt, rhs, rhs_vt )
	swend
	
	// [B] rhs EӒlł鉉Z
	rhs = evaler_PopAsRVal( thismod, rhs_vt )
	
	switch ( optype )
		//  ':'
		case BinOp_Pair:
			lhs = evaler_PopAsRValOrIdent( thismod, lhs_vt )
			return evaler_ProcOpBin_Pair( thismod, optype, resVt, lhs, lhs_vt, rhs, rhs_vt )
			
		//  '?', Null '??'
		case BinOp_Which:
		case BinOp_NullOr:
			lhs = evaler_PopAsRVal( thismod, lhs_vt )
			return evaler_ProcOpBin_WhichOrNullOr( thismod, optype, resVt, lhs, lhs_vt, rhs, rhs_vt )
			
		// _ '=>'
		case BinOp_Lambda:
			lhs = evaler_PopAsImpl( thismod, lhs_vt )
			return evaler_ProcOpBin_Lambda( thismod, optype, resVt, lhs, lhs_vt, rhs, rhs_vt )
			
		// 
		case_if ( EnumRange_BinOp_Assign(optype) ):
			return evaler_ProcOpBin_AssignWrap( thismod, optype, resVt, rhs, rhs_vt )		// ӂ͊֐Ŏ
			
		// ( EӂŁAZ _ łȂ ) => 򉉎Z
		case_if ( rhs_vt == Valtype_Block && not EnumRange_BinOp_Log(optype) ):
			lhs = evaler_PopAsRVal( thismod, lhs_vt )
			return evaler_ProcOpBin_Block( thismod, optype, resVt, lhs, lhs_vt, rhs, rhs_vt )
	swend
	
	// [C] lhs, rhs EӒlł鉉Z
	lhs = evaler_PopAsRVal( thismod, lhs_vt )	// ӂEӒlƂĎo
	
	switch
		// lZ
		case ( evaler_ProcOpBin_TryTuple( thismod, optype, resVt, (lhs), lhs, lhs_vt, rhs, rhs_vt ) ):
			return lhs
			
		// 򉉎Z
		case ( lhs_vt == Valtype_Block ):
			return evaler_ProcOpBin_Block( thismod, optype, resVt, lhs, lhs_vt, rhs, rhs_vt )
			
		// 
		case ( optype == BinOp_Belong ):
			return evaler_ProcOpBin_Belong( thismod, optype, resVt, lhs, lhs_vt, rhs, rhs_vt )
			
		// ֌W
		case ( EnumRange_BinOp_Rel(optype) ):
			return evaler_ProcOpBin_Relation( thismod, optype, resVt, lhs, lhs_vt, rhs, rhs_vt )
			
		// Az̉Z
		case ( lhs_vt == Valtype_Assoc ):
			return evaler_ProcOpBin_Assoc( thismod, optype, lhs, resVt, rhs, rhs_vt )
			
		// _
		case ( EnumRange_BinOp_Log(optype) ):
			return evaler_ProcOpBin_Log( thismod, optype, resVt, lhs, lhs_vt, rhs, rhs_vt )
			
		// rbg
		case ( EnumRange_BinOp_Bit(optype) ):
			return evaler_ProcOpBin_Bit( thismod, optype, resVt, lhs, lhs_vt, rhs, rhs_vt )
			
		// Zp
		case ( EnumRange_BinOp_Arith(optype) ):
			return evaler_ProcOpBin_Arith( thismod, optype, resVt, lhs, lhs_vt, rhs, rhs_vt )
	swend
	assert
	
//------------------------------------------------
// 񍀉Z:: (bv)
// 
// @ X^bN獶ӂoB
// @ ӂ vector eȂ瑽dsB
// @ ӎʎq͓WJȂ܂ܓnB
//------------------------------------------------
#modcfunc evaler_ProcOpBin_AssignWrap int optype, var resVt, var rhs, var rhs_vt, \
	local lhs, local lhs_vt
	
	// ӂ ʎq
	if ( Stack_peek( mStkCalc(1) ) == Valtype_Ident ) {
		Stack_remove mStkCalc(1)
		
		lhs    = Stack_pop( mStkCalc(0) )
		lhs_vt = Valtype_Ident
		
	// ӂ vector (e) => d, vector
	} elsif ( Stack_peek( mStkCalc(1) ) == Valtype_Assoc ) {
		Stack_remove mStkCalc(1)
		lhs = Stack_pop( mStkCalc(0) )				// lhs  assoc
		
		return evaler_ProcOpBin_Assign_Vector( thismod, optype, resVt, lhs, rhs, rhs_vt )		// [lhs]  rhs
		
	// ӂ ӒlWJ
	} else {
		lhs = evaler_PopAsLVal( thismod, lhs_vt )
		
		// 򉉎Z
		if ( lhs_vt == Valtype_Block ) {
			return evaler_ProcOpBin_Block( thismod, optype, resVt, lhs, lhs_vt, rhs, rhs_vt )
		}
	}
	
	return evaler_ProcOpBin_Assign( thismod, optype, resVt, lhs, lhs_vt, rhs, rhs_vt )
	
//**********************************************************
//        XgZ
//**********************************************************
//------------------------------------------------
// PZ::XgZĂяo (bv)
// 
// @ X^bNXgoB
//------------------------------------------------
#modcfunc evaler_CallOpUni_ListWrap int optype, var resVt,  \
	local lhs, local lhs_vt, \
	local arglist
	
	// X^bNɂ [arglist, ] ͂ (ǂWJ)
	assert ( Stack_peek( mStkCalc(1) ) == Valtype_Arglist )
	
	// @ lhs:      (֐, vector ȂǁAʂ̍ɂ)
	// @ arglist: vector e
	arglist = evaler_PopAsImpl( thismod, resVt )
	lhs     = evaler_PopAsRVal( thismod, lhs_vt )	// ͉̂EӒlƂĎ擾 => (lhs = valFunc or iVec)
	dbgout "call/index: remove lhs-object( " + lhs + " : " + lhs_vt + " )"
	
	return evaler_CallOpUni_List( thismod, optype, resVt, lhs, lhs_vt, arglist )
	
//------------------------------------------------
// PZ::XgZĂяo
// 
// @ callable, indexable ̎s
//------------------------------------------------
#modcfunc evaler_CallOpUni_List int optype, var resVt, var self, var self_vt, int arglist,  local rhs, local rhs_vt
	
	assert which( optype == PostfixOp_Call, EnumRange_Valtype_Callable(self_vt) || EnumRange_Valtype_Numeric(self_vt), EnumRange_Valtype_Indexable(self_vt) )
	
	// lZ
	if ( IsTuple(self, self_vt) ) {
		return evaler_ProcOpList_Tuple( thismod, self, resVt, optype, arglist )
	}
	
	// Az̉Z
	if ( self_vt == Valtype_Assoc ) {
		return evaler_ProcOp_Assoc_Impl( thismod, self, resVt, OpFuncName( GetName_UniOp(optype) ), arglist )
	}
	
	// ֐ ( )
	if ( optype == PostfixOp_Call ) {
		switch ( self_vt )
			case Valtype_Func:
				return evaler_CallFunc( thismod, resVt, assocNull, self, arglist )		// ֐Ăяo
				
			case Valtype_Method:
				return evaler_CallFunc( thismod, resVt, pair_getLhs(self), pair_getRhs(self), arglist )	// this tŊ֐Ăяo
				
			case Valtype_Block:
				self = evaler_SpecializeBlock( thismod, resVt, self, arglist )			// ꉻ
				return evaler_ProcBlock( thismod, assocNull, self, resVt )
				
			case Valtype_Int:
			case Valtype_Double:
				if ( vector_Size(arglist) != 1 ) { PutError Error_Argc }
				rhs = var_GetValue( vector_Get(arglist, 0), rhs_vt )
				evaler_ExpandValueAsRVal thismod, rhs, rhs_vt	// EӒlWJ
				
				// 򉉎Z
				if ( rhs_vt == Valtype_Block ) {
					return evaler_ProcOpBin_Block( thismod, BinOp_Trans, resVt, self, self_vt, rhs, rhs_vt )
				}
				
				// Z
				return evaler_ProcOpBin_Arith( thismod, BinOp_Mul, resVt, self, self_vt, rhs, rhs_vt )
				
			default:
				logmes "[Error] when PZ(call)\n֐q (" + DecodeEvalElem(self_vt, self) + ") ĂтƂ"
				PutError Error_NeedCallable
		swend
		
	// Y [ ]
	} elsif ( optype == PostfixOp_Index ) {
		switch ( self_vt )
			case Valtype_Func:
				resVt = Valtype_Func
				return StrCalc_BindFunc( self, arglist, miEnv )		// ֐
				
			case Valtype_Method:
				resVt = Valtype_Method
				return StrCalc_BindMethod( self, arglist, miEnv )
				
			case Valtype_Block:
				resVt = Valtype_Block
				return evaler_SpecializeBlock( thismod, resVt, self, arglist )			// ꉻ
				
			default:
				logmes "[Error] when PZ(index)\nYq (" + DecodeEvalElem(self_vt, self) + ") ɓY^"
				PutError Error_NeedIndexable
		swend
	}
	
	return
	
//------------------------------------------------
// ֐::Ăяo
//------------------------------------------------
#modcfunc evaler_CallFunc var resVt, int thisAssoc, int valFunc_, int arglist_,  \
	local valFunc, local arglist, \
	local iFunc, local iPlugin, local cntArgs, \
	local result
	
	valFunc = valFunc_
	arglist = arglist_
	
	// WJ (̊֐𓾂)
	if ( func_IsBound( FuncId(valFunc) ) ) {
		valFunc = func_Unbind( FuncId(valFunc), arglist )
	}
	
	iPlugin = PluginId(valFunc)
	iFunc   = FuncId(valFunc)
	cntArgs = vector_Size(arglist)
	
	dbgout "call func: " + func_GetName(iFunc) + " = ( " + DecodeValue_Func(iFunc) + " )"
	
	// KvȂEӒlWJ
	if ( IsExpandNeeded(iPlugin, iFunc) ) { evaler_ExpandArglist thismod, arglist }
	
	
	if ( func_GetCntPrms(iFunc) == 1 && cntArgs >= 2 ) {		// 1 ֐ɕ̈ => evf
		result = new_tuple( miEnv )
		repeat cntArgs
			vector_PushBack result, evaler_CallFuncImpl( thismod, thisAssoc, iPlugin, iFunc, resVt, vector_PickOne(arglist, cnt), 1 ), resVt, dbgcode("called_tuple#" + cnt, )
		loop
		resVt = Valtype_Assoc
		
	} else {
		result = evaler_CallFuncImpl( thismod, thisAssoc, iPlugin, iFunc, resVt, arglist, cntArgs )
	}
	
	dbgout "func result: " + result + " <" + EnumString_Valtype(resVt) + ">"
	if ( stt_error ) { assert : resVt = Valtype_Error : PutError }
	
	return result
	
#modcfunc evaler_CallFuncImpl int thisAssoc, int iPlugin, int iFunc, var resVt, int arglist, int cntArgs
	switch ( iPlugin )
		case PlugIn_Userdef:   return evaler_ProcFuncUserdef  ( thismod, thisAssoc, iFunc, resVt, arglist, cntArgs ) : swbreak
		case PlugIn_System:    return evaler_ProcFuncSystem   ( thismod, thisAssoc, iFunc, resVt, arglist, cntArgs ) : swbreak
		case PlugIn_Dev:       return evaler_ProcFuncDev      ( thismod, thisAssoc, iFunc, resVt, arglist, cntArgs ) : swbreak
		case PlugIn_Syntax:    return evaler_ProcFuncSyntax   ( thismod, thisAssoc, iFunc, resVt, arglist, cntArgs ) : swbreak
		case PlugIn_Type:      return evaler_ProcFuncType     ( thismod, thisAssoc, iFunc, resVt, arglist, cntArgs ) : swbreak
		case PlugIn_Operation: return evaler_ProcFuncOperation( thismod, thisAssoc, iFunc, resVt, arglist, cntArgs ) : swbreak
		
		case PlugIn_Math:      return StrCalc_ProcFuncMath( thisAssoc, iFunc, resVt, arglist, cntArgs, miEnv ) : swbreak
		default:
			return plugin_Proc( iPlugin, thismod, thisAssoc, iFunc, resVt, arglist, cntArgs, miEnv )
	swend
	
//------------------------------------------------
// EӒlWJׂ
//------------------------------------------------
#defcfunc IsExpandNeeded@MCEvaler int iPlugin, int iFunc,  local bNoExpand
	
	// System: Func_System_Argv O͉EӒlWJȂ
	bNoExpand |= ( iPlugin == PlugIn_System && (iFunc < Func_System_Argv) ) : if ( bNoExpand ) { return false }
	
	// Syntax: for ͉EӒlWJȂ
	bNoExpand |= ( iPlugin == PlugIn_Syntax && (iFunc == Func_Syntax_For) ) : if ( bNoExpand ) { return false }
	
	// Type: ident, var, assoc, func, method, propaty, refarg,  class, vector, pair ͉EӒlWJȂ
	if ( iPlugin == PlugIn_Type ) {
		bNoExpand |= eq_or(iFunc, Func_Type_Ident, Func_Type_Var, Func_Type_Assoc, Func_Type_Func, Func_Type_Method, Func_Type_Propaty, Func_Type_RefArg,  Func_Type_Class, Func_Type_Vector, Func_Type_Pair)
	}
	
	// Operation: EӒlWJȂ
	bNoExpand |= ( iPlugin == PlugIn_Operation )
	
	return (not bNoExpand)		// uWJ邩HvԂ
	
//------------------------------------------------
// ::ꉻ
//------------------------------------------------
#modcfunc evaler_SpecializeBlock var resVt, int src, int arglist
	return StrCalc_SpecializeBlock( thismod, arglist, resVt, assocNull, src )
	
