// StrCalc Plugin - pair

#ifndef IG_STRCALC_PLUGIN_PAIR_AS
#define IG_STRCALC_PLUGIN_PAIR_AS

// Pair p̃vOC
// @ eXg
// @ uvOCv̎dlS~Ȃ̂ŃR[hAB

#include "MCPlugin.as"

#module _plg_pair

#include "header_inner.as"

#deffunc PluginPair_Init
	
	// namespace Pair
	plugin_New stt_env_global, "Pair"
		plugin_pair = stat
		assoc_pair  = plugin_GetAssoc(plugin_pair)
		
	plugin_SetLabel plugin_pair, *LProcFunc
	
	plugin_DefFunc plugin_pair, "dup",     0, true : func_pair_dup     = stat
;	plugin_DefFunc plugin_pair, "swap",    0, true : func_pair_swap    = stat
	
	return plugin_pair
	
#define ctype SetResult(%1 = thisAssoc, %2 = Valtype_Assoc) result = (%1) : resVt = (%2)

#deffunc local _dummy_proc var lbProc, var thisEval, int thisAssoc, int iFunc, var result, var resVt, int arglist, int cntArgs, int iEnv
*LProcFunc
	if ( thisAssoc == assocNull ) {
		PutError Error_InvalidValue
	}
	
	switch ( iFunc )
		case func_pair_dup:
			tmp(0) = new_assoc( iEnv )
			tmp(1) = assoc_Find(thisAssoc, "lhs")
			tmp(2) = assoc_Find(thisAssoc, "rhs")
			
			assoc_DefVar result, "prototype", stt_assoc_pair, Valtype_Assoc
			assoc_DefVar result, "lhs", var_Get( tmp(1) ), var_GetType( tmp(1) )
			assoc_DefVar result, "rhs", var_Get( tmp(2) ), var_GetType( tmp(2) )
			
			SetResult( tmp(0) )
			swbreak
			
	;	case func_vector_swap:
	;	case func_vector_reverse:
			;
	;		SetResult()
	;		swbreak
			
		default:
			assert
	swend
	return
	
#global

#endif
