// StrCalc - encode

#ifndef IG_MODULE_STRCALC_ENCODE_AS
#define IG_MODULE_STRCALC_ENCODE_AS

#include "Mo/abdata/queue.as"

#module mod_StrCalc_encode

#include "header_inner.as"

//------------------------------------------------
// g[N̕
// 
// @cnv: [g[N, g[N]
//     [g[N, g[N]
// @ 悤ȃR[hĕ|B
//------------------------------------------------
#deffunc StrCalc_Encode array ioQueue,  \
	local lenQueue, local idxToken, \
	local outQueue, local nxtType, local nxtToken, local nowType, local nowToken, local befType, \
	local cntNestArg, local nestArgBracketL, local cntArgItems, \
	local cntNestIdx, local nestIdxBracketL, local cntIdxItems, \
	local cntNestArr, local nestArrBracketL, local cntArrItems, \
	local cntNestBlk, local nestBlkBracketL, local cntBlkItems, local bTrailBlock, \
	local cntNestTup, local nestTupBracketL, local cntTupItems,  local idxTupLPlace, \
	local nestBracket, local bArgBracket, local bIdxBracket, local bArrBracket
	
	dbgout "\nE(encode)"
	
	dim outQueue
	
	repeat 2
		Queue_new outQueue(cnt)		// tktype, ڍ
	loop
	
	befType = TkType_None
	nowType = TkType_None
	
	nestBracket = 0			// ʂ̑Ή ( ʂ ++AEʂ -- )
	
	cntNestArg      = -1	// ݉͒̈ʂ̐[
	nestArgBracketL = 0		// ()̐[ (ʂIׂ[m邽) (stk; Y cntNextArg p)
	cntArgItems     = 0		// ̐L (stk)
	
	cntNestIdx      = -1	// [ ] (Y)
	nestIdxBracketL = 0
	cntIdxItems     = 0
	
	cntNestArr      = -1	// [ ] (z񊇌)
	nestArrBracketL = 0
	cntArrItems     = 0
	
	cntNestBlk      = -1	// { } (򊇌)
	nestBlkBracketL = 0
;	cntBlkItems     = 0			// sv
	bTrailBlock     = false		// ֌㑱鎮򂩁H ( func() { } ) (stk)
	
	cntNestTup      = -1	// ( ) (l; or Z)
	nestTupBracketL = 0
	cntTupItems     = 0			// Z (, ܂܂Ȃꍇ) ̂Ƃ 0 (stk)
	idxTupLPlace    = 0			// Ή鍶ʂ̎́AoutQueue ɂ idx (stk); ŉZʂɏ邽
	
	lenQueue = Queue_size( ioQueue(0) )
	idxToken = 0
	
	repeat
		
		// f[^̍XV
		if ( idxToken < lenQueue ) {
			gosub *LPopNextData
		} else {
			break
		}
		
		// ʂ̃lXgĎ
		if ( IsBracketL(nowType) ) { nestBracket ++ }
		if ( IsBracketR(nowType) ) { nestBracket -- }
		
		if ( nestBracket < 0 ) { stt_error = Error_Bracket : break }	// Eʂ
		
		// 򏈗
		gosub *LProcEncode
		if ( stt_error ) { break }
		
	loop
	if ( stt_error ) { return }
	
	// Ōオ 񍀉Zq or PZq::Ou G[
	if ( befType == TkType_BinOp || befType == TkType_PrefixOp ) { PutError Error_Syntax }
	
	// ʂΉĂȂ
	if ( nestBracket != 0 ) { PutError Error_Bracket }
	
	// ioQueue Ɍʂ߂
	foreach ioQueue
		Queue_delete ioQueue(cnt)		// ̓L[͕svȂ̂ō폜
		ioQueue(cnt) = outQueue(cnt)	// QƂn
	loop
	
#ifdef _MODE_STRCALC_DEBUG_OUTPUT
	dbgout "Eg[N::O"
	Queue_dbglog ioQueue(1)
#endif
	return
	
*LPopNextData
	befType  = nowType
	
	nowType  = Queue_peek( ioQueue(0), idxToken )
	nowToken = Queue_peek( ioQueue(1), idxToken )
	idxToken ++
	
	if ( idxToken < lenQueue ) {
		nxtType  = Queue_peek( ioQueue(0), idxToken )
		nxtToken = Queue_peek( ioQueue(1), idxToken )
		
	} else {
		nxtType  = TkType_None
		nxtToken = ""
	}
	
	return
	
*LProcEncode
;	dbgout "next: ( " + nowType + ", " + nowToken + " )"
	
	//-----------------------------------------------
	// ʎq | 
	//-----------------------------------------------
	if ( nowType == TkType_Ident || nowType == TkType_String ) {
		if ( IsBefValueType(befType) ) { PushToQueue outQueue, TkType_BinOp, BinOp_Trans }	// ϊ
		gosub *LNormalPush
		
	//-----------------------------------------------
	// l
	//-----------------------------------------------
	} elsif ( nowType == TkType_Int ) {
		if ( IsBefValueType(befType) && IsNumberType(befType) == false ) { PushToQueue outQueue, TkType_BinOp, BinOp_Trans }	// ϊ
		PushToQueue outQueue, nowType, int( nowToken )
		
	} elsif ( nowType == TkType_Double ) {
		if ( IsBefValueType(befType) && IsNumberType(befType) == false ) { PushToQueue outQueue, TkType_BinOp, BinOp_Trans }	// ϊ
		PushToQueue outQueue, nowType, double( nowToken )
		
	//-----------------------------------------------
	// ۊ::
	//-----------------------------------------------
	} elsif ( nowType == TkType_ParenL ) {
		
		// O l => ::
		if ( IsBefValueType(befType) ) {
			nowType = TkType_ArgL
			cntNestArg ++
			
			// ʉ̓f[^
			nestArgBracketL( cntNestArg ) = nestBracket		// ݂̊ʂ̑ΉL
			cntArgItems( cntNestArg )     = 0				// ̐
			
			// ::
			PushToQueue outQueue, TkType_ArgL, dbgcode("(", 0)
			
			// Z '(' ǉ ( ̗̎D揇ʂ邽 )
			PushToQueue outQueue, TkType_ParenL, dbgcode("(", 0)
			
		// l; or Z
		} else {
			gosub *LNormalPush /*
			
			cntNestTup ++
			
			// ʉ̓f[^
			nestTupBracketL( cntNestTup ) = nestBracket		// ݂̊ʂ̑ΉL
			cntTupItems( cntNestTup )     = 0				// vf
			
			// l::
			PushToQueue outQueue, TkType_TupleL, dbgcode("(", 0)
			idxTupLPlace( cntNestTup ) = Queue_size( outQueue(0) ) - 1	// ʒuۑ
			
			// Z '(' ǉ ( e̗̎D揇ʂ邽 )
			PushToQueue outQueue, TkType_ParenL, dbgcode("(", 0)
			//*/
		}
		
	//-----------------------------------------------
	// ۊ::E
	//-----------------------------------------------
	} elsif ( nowType == TkType_ParenR ) {
		
		// bef  l  '('  ',' łȂȂA@G[
		if ( not(IsBefValueType(befType) || befType == TkType_ParenL || befType == TkType_ArgL || befType == TkType_Comma) ) { PutError Error_Syntax }
		
		bArgBracket = false
		
		// ::E Ȃ
		if and( (cntNestArg >= 0), ( (nestBracket + 1) == nestArgBracketL(cntNestArg) ) ) {
			nowType = TkType_ArgR
			
			// Ō̈ȗĂ( f( a, ) )
			if ( befType == TkType_Comma ) {
				PushToQueue outQueue, TkType_Omission, dbgcode("omission", 0)			// ȗl
				cntArgItems(cntNestArg) ++
				
			} elsif ( IsBefValueType(befType) ) {		// OɈ( f(x, y) )
				cntArgItems(cntNestArg) ++
				
			} elsif ( befType != TkType_ArgL ) {
				logmes " ')' ̈ʒusK"
				PutError Error_Syntax
			}
			
			PushToQueue outQueue, TkType_ParenR, dbgcode(")", 0)	// (Ō̈)Eʂo
			
			// 򃊃e㑱 => o͏x
			if ( nxtType == TkType_BlockL ) {
				bTrailBlock( cntNestBlk + 1 ) = true	// ̎ɎwtO𗧂ĂĂ
				
			// ʂ̏o
			} else {
				gosub *LProcEncode_AddBracketArgR
			}
			
			// ʂ̏o
			do_not {
			:*LProcEncode_AddBracketArgR:
				
				// ::E
				PushToQueue outQueue, TkType_ArgR, dbgcode(")", 0)
				
				// ֐ĂяoZq ()
			;	PushToQueue outQueue, TkType_PostfixOp, PostfixOp_Call
				
				cntNestArg --
				return
			}
			
		// l; or Z
		} else {
		;	assert and( cntNestTup >= 0, ( nestBracket + 1 == nestTupBracketL(cntNestTup) ) )
			
			// gu( )v => ȗlo
			if ( befType == TkType_ParenL ) {
				PushToQueue outQueue, TkType_Omission, dbgcode("omission", 0)
			}
			
			gosub *LNormalPush /*
			
			// Ō̈ȗĂ ( (a, ) ) => lʂƂĂ̖, 邢͏璷 ','
			if ( befType == TkType_Comma ) {
				if ( cntTupItems(cntNestTup) == 0 ) {
					cntTupItems(cntNestTup) ++			// 0  1
				}
				
			} elsif ( befType != TkType_ParenL ) {		// OɈ( (x, y) )
				if ( cntTupItems(cntNestTup) != 0 ) {	// vf 0 ȂẢZʂƂ
					cntTupItems(cntNestTup) ++
				}
			}
			
			PushToQueue outQueue, TkType_ParenR, dbgcode(")", 0)	// (Ō̈)Eʂo
			
			// Zʂ => ʂ TkType_ParenL ɏ
			if ( cntTupItems(cntNestTup) == 0 ) {
				Queue_set outQueue(0), TkType_ParenL, idxTupLPlace(cntNestTup)
				PushToQueue outQueue, TkType_ParenR, dbgcode(")", 0)
				
			} else {
				PushToQueue outQueue, TkType_TupleR, dbgcode(")", 0)
			}
			
			cntNestTup --
			//*/
		}
		
	//-----------------------------------------------
	// g:: '{'
	//-----------------------------------------------
	} elsif ( nowType == TkType_BlockL ) {
		
		// O lłȂ => @G[
		if ( IsBefValueType(befType) ) {
			bTrailBlock( cntNestBlk + 1 ) += 0		// ꉞAg
			
			// A㑱̏ꍇ́A')' ŏIĂĂ
			if and( befType == TkType_ArgR, length(bTrailBlock) > (cntNestBlk + 1), bTrailBlock(cntNestBlk + 1) ) {
				;
			} else {
				PushToQueue outQueue, TkType_BinOp, BinOp_Trans		// ϊ
			;	PutError Error_Syntax		// (ϊȂꍇ)@G[
			}
		}
		
		cntNestBlk ++
		
		nestBlkBracketL( cntNestBlk ) = nestBracket			// ݂̊ʂ̑ΉL
	;	cntBlkItems( cntNestBlk ) = 0		// gȂ
	;	bTrailBlock( cntNestBlk )			// ɏĂ
		
		gosub *LNormalPush
		
	//-----------------------------------------------
	// g::E '}'
	//-----------------------------------------------
	} elsif ( nowType == TkType_BlockR ) {
		
		if ( cntNestBlk < 0 ) {
			dbgout( "g::E } B\n" + dbgstr(cntNestBlk) )
			PutError Error_Bracket
		}
		
		// lŏIĂȂꍇ͕@G[ (  { } ̏Ԃ͗O )
		if ( not IsBefValueType(befType) && befType != TkType_BlockL ) {
			PutError Error_Syntax
		}
		
		// o
		gosub *LNormalPush
		
		// 򃊃e㑱ꍇA̍Ō
		if and( length(bTrailBlock) > cntNestBlk, bTrailBlock( cntNestBlk ) ) {
			gosub *LProcEncode_AddBracketArgR
			bTrailBlock( cntNestBlk ) = false
		}
		
		cntNestBlk --
		
	//-----------------------------------------------
	// p:: '['
	//-----------------------------------------------
	} elsif ( nowType == TkType_ArrayL ) {
		
		// O l or E => Y
		if ( IsValueType(befType) || IsBracketR(befType) ) {
			cntNestIdx ++
			
			// ʉ̓f[^
			nestIdxBracketL( cntNestIdx ) = nestBracket		// ݂̊ʂ̑ΉL
			cntIdxItems( cntNestIdx )     = 0				// 
			
			nowType = TkType_IndexL
			
		// z񊇌
		} else {
			cntNestArr ++
			
			// ʉ̓f[^
			nestArrBracketL( cntNestArr ) = nestBracket		// ݂̊ʂ̑ΉL
			cntArrItems( cntNestArr )     = 0				// 
			
		;	nowType = TkType_ArrayL
		}
		
		// (z or Y)::
		PushToQueue outQueue, nowType, dbgcode("[", 0)
		
		// Z '(' ǉ ( ̗̎D揇ʂ邽 )
		PushToQueue outQueue, TkType_ParenL, dbgcode("(", 0)
		
	//-----------------------------------------------
	// p::E ']'
	//-----------------------------------------------
	} elsif ( nowType == TkType_ArrayR ) {
		
		if ( cntNestIdx < 0 && cntNestArr < 0 ) {
			dbgout( "p::E ] B\n" + dbgpair(cntNestIdx, cntNestArr))
			PutError Error_Bracket
		}
		
		// Ō̎l , ŏIĂȂȂ當@G[ ( [ ]  ok)
		if ( not IsBefValueType(befType) && befType != TkType_Comma && (befType != TkType_ArrayL && befType != TkType_IndexL) ) {
			PutError Error_Syntax
		}
		
		bArrBracket = true
		bIdxBracket = false
		
		// Y::E Ȃ
		if and( (cntNestIdx >= 0), (nestBracket + 1) == nestIdxBracketL(cntNestIdx) ) {
			bArrBracket = false
			bIdxBracket = true
			nowType = TkType_IndexR
		}
		
		// Ō̍ȗĂ( a[ x, ] )
		if ( befType == TkType_Comma ) {
			if ( bIdxBracket ) {
				PushToQueue outQueue, TkType_Omission, dbgcode("omission", 0)		// ȗl
				cntIdxItems(cntNestIdx) ++
			} else {
			;	cntArrItems(cntNestArr) ++		// Ō , 𖳎
			}
			
		// OɈ( a[x, y] or [x, y] )
		} elsif ( (bIdxBracket && befType != TkType_IndexL) || (bArrBracket && befType != TkType_ArrayL) ) {
			if ( bIdxBracket ) {
				cntIdxItems(cntNestIdx) ++
			} else {
				cntArrItems(cntNestArr) ++
			}
		}
		
		// 
		argc = which( bIdxBracket, cntIdxItems(cntNestIdx), cntArrItems(cntNestArr) )	
		
		PushToQueue outQueue, TkType_ParenR, dbgcode(")", 0)			// (Ō̈)Eʂo
	;	PushToQueue outQueue, TkType_Comma,  dbgcode(",", 0)
	;	PushToQueue outQueue, TkType_Int,    int( argc )				// o
		
		// Y::E
		PushToQueue outQueue, nowType, dbgcode("]", 0)
		
		// YĂяoZq []
	;	PushToQueue outQueue, TkType_PostfixOp, PostfixOp_Index
		
		if ( bIdxBracket ) {
			cntNestIdx --
		} else {
			cntNestArr --
		}
		
	//-----------------------------------------------
	// 錾
	// 
	// @syntax: 錾q ̎ʎq ̎ʎq (PZq|(?:'('))
	// @impl:
	// @	錾q́A̕(encode)_ŏłB
	// @	2̎ʎqoÂ悤ɕϊB
	// @		ident:"var" ( ident2 ) operator:= new[ident1]
	// @	ȂAʂł͂ȂZqꍇ́A +> ǉB
	//-----------------------------------------------
	} elsif ( nowType == TkType_Declare ) {
		// ̐擪Ɍ (O JnL |  | 񍀉Zq | , ̂)
		if not( befType == TkType_None || IsBracketL(befType) || befType == TkType_BinOp || befType == TkType_Comma ) {
			PutError Error_Syntax
		}
		
		sdim ident, , 2
		
		gosub *LPopNextData : ident(0) = nowToken	// ̎ʎq (bef ƂȂ)
		gosub *LPopNextData : ident(1) = nowToken	// ̎ʎq (now ƂȂ)
		
		if ( befType != TkType_Ident || nowType != TkType_Ident ) {
			logmes "[Error] when g[N\n錾ɂ2̎ʎqKvB"
			PutError Error_Syntax
		}
		
		// ό`̌`Ńg[No
		PushToQueue outQueue, TkType_Ident, "var"
		PushToQueue outQueue, TkType_ArgL,   dbgcode("(", 0)
		PushToQueue outQueue, TkType_Ident, ident(1)		// (var ̈)
		PushToQueue outQueue, TkType_ArgR,  dbgcode(")", 0)
		PushToQueue outQueue, TkType_BinOp, BinOp_Set		// :=
		PushToQueue outQueue, TkType_Ident, "new"			// new
		PushToQueue outQueue, TkType_IndexL, dbgcode("[", 0)
		PushToQueue outQueue, TkType_Ident, ident(0)
		PushToQueue outQueue, TkType_IndexR, dbgcode("]", 0)
		
		if ( nxtToken == ":=" ) {
			gosub *LPopNextData			// ":=" 
			PushToQueue outQueue, TkType_BinOp, BinOp_Trans		// ϊ (+>)
		} elsif ( nxtToken == "(" ) {
			;
		} else {
			logmes "[Error] when g[N\n錾ŁA̎ʎq̎ɂ '('  := Kv"
			PutError Error_Syntax
		}
		
	//-----------------------------------------------
	// J}
	// 
	// @ Xg̋؂ | 񍀉Zq | uPZq
	//-----------------------------------------------
	} elsif ( nowType == TkType_Comma ) {
		
		// ʂ̒H
		bArgBracket = and( (cntNestArg >= 0), ( nestBracket == nestArgBracketL(cntNestArg) ) )
		bIdxBracket = and( (cntNestIdx >= 0), ( nestBracket == nestIdxBracketL(cntNestIdx) ) )
		bArrBracket = and( (cntNestArr >= 0), ( nestBracket == nestArrBracketL(cntNestArr) ) )
		bTupBracket = and( (cntNestTup >= 0), ( nestBracket == nestTupBracketL(cntNestTup) ) )
		
		// Xg̋؂
		if ( bArgBracket || bIdxBracket || bArrBracket || bTupBracket ) {
			
			// ȗꂽ
			if ( befType == TkType_Comma || (bArgBracket && befType == TkType_ArgL) || (bIdxBracket && befType == TkType_IndexL) || (bArrBracket && befType == TkType_ArrayL) || (bTupBracket && befType == TkType_ParenL) ) {
				PushToQueue outQueue, TkType_Omission, dbgcode("omission", 0)
			}
			
			// ) , ( ɂȂ
			PushToQueue outQueue, TkType_ParenR, dbgcode(")", 0)
			PushToQueue outQueue, TkType_Comma,  dbgcode(",", 0)
			PushToQueue outQueue, TkType_ParenL, dbgcode("(", 0)
			
			// ̐𐔂
			if ( bArgBracket ) {
				cntArgItems(cntNestArg) ++
			} elsif ( bIdxBracket ) {
				cntIdxItems(cntNestIdx) ++
			} elsif ( bArrBracket ) {
				cntArrItems(cntNestArr) ++
			} else {
				cntTupItems(cntNestTup) ++
			}
			
		// 񍀉Zq or uPZq
		} else {
			if ( not IsBefValueType(befType) ) { logmes dbgstr(befType) : logmes dbgstr(nowType) : PutError Error_Syntax }
			
			//   OuZqɐ蓾ȂZq | , | E | I[ => u
			if ( (IsOperatorType(nxtType) && not IsPrefixOpStr(nxtToken)) || IsBracketR(nxtType) || nxtType == TkType_None ) {
		;	if ( not IsValueType(nxtType) && (not IsOperatorType(nxtType) && not IsBracketL(nxtType) || (nxtToken == "," || nxtToken == ";") || IsBracketR(nxtType) || nxtType == TkType_None) ) {
				nowType = TkType_PostfixOp
				PushToQueue outQueue, nowType, PostfixOp_Tuple
				
			} else {
				nowType  = TkType_BinOp
			;	nowToken = ","
				goto *LProcAsBinOp
			}
			
		;	logmes "[Error] when g[N\nʁEYʁEz񊇌ʂ̊OŃJ} , gꂽB"
		;	PutError Error_Syntax
		}
		
	//-----------------------------------------------
	// PZq::Ou
	// 
	// @ O l łȂ
	//-----------------------------------------------
	} elsif ( IsOperatorType(nowType) && IsPrefixOpStr(nowToken) && not IsBefValueType(befType) ) {
		
		nowType = TkType_PrefixOp
		switch ( nowToken )
			case "+":  PushToQueue outQueue, nowType, PrefixOp_Plus  : swbreak
			case "-":  PushToQueue outQueue, nowType, PrefixOp_Minus : swbreak
			case "/":  PushToQueue outQueue, nowType, PrefixOp_Inv   : swbreak
			case "^":  PushToQueue outQueue, nowType, PrefixOp_Exp   : swbreak
			case "//": PushToQueue outQueue, nowType, PrefixOp_Sqrt  : swbreak
			case "~":  PushToQueue outQueue, nowType, PrefixOp_Not   : swbreak
			
			case "!":  PushToQueue outQueue, nowType, PrefixOp_Neg   : swbreak
			case "=>": PushToQueue outQueue, nowType, PrefixOp_Func  : swbreak
			case "++": PushToQueue outQueue, nowType, PrefixOp_Inc   : swbreak
			case "--": PushToQueue outQueue, nowType, PrefixOp_Dec   : swbreak
		swend
		
	//-----------------------------------------------
	// PZq::u
	// 
	// @ G
	//-----------------------------------------------
	// ('!' | '++' | '--')
	// => (̎_őOuł͂Ȃ̂) Ku
	} elsif ( IsOperatorType(nowType) && eq_or(nowToken, "!", "++", "--") ) {
		
		nowType = TkType_PostfixOp
		switch ( nowToken )
			xcase "!":  PushToQueue outQueue, nowType, PostfixOp_Fact
			xcase "++": PushToQueue outQueue, nowType, PostfixOp_Inc
			xcase "--": PushToQueue outQueue, nowType, PostfixOp_Dec
		swend
		
	// ('%')
	//  uɌ鉉Zq(nothing) | E | I[ => u (񍀉ZD)
	} elsif ( IsOperatorType(nowType) && (nowToken == "%") && (IsOperatorType(nxtType) || IsBracketR(nxtType) || nxtType == TkType_None) ) {
		
		nowType = TkType_PostfixOp
		PushToQueue outQueue, nowType, PostfixOp_Percent
		
	// (';')
	// ̍Ō ( E | I[) => u
	} elsif ( IsOperatorType(nowType) && (nowToken == ";") && (IsBracketR(nxtType) || nxtType == TkType_None) ) {
		
		nowType = TkType_PostfixOp
	;	PushToQueue outQueue, nowType, PostfixOp_Snake		// ֑Zq ()
		
	//-----------------------------------------------
	// 񍀉Zq
	// 
	// @ ̑
	//-----------------------------------------------
	} elsif ( IsOperatorType(nowType) ) {
	:*LProcAsBinOp
		nowType = TkType_BinOp
		switch ( nowToken )
			case ";"  : PushToQueue outQueue, nowType, BinOp_Split    : swbreak
			
			case ":=" : PushToQueue outQueue, nowType, BinOp_Set      : swbreak
			case "<->": PushToQueue outQueue, nowType, BinOp_Swap     : swbreak
			
			case ","  : PushToQueue outQueue, nowType, BinOp_Tuple    : swbreak
			
			case ":"  : PushToQueue outQueue, nowType, BinOp_Pair     : swbreak
			case "?"  : PushToQueue outQueue, nowType, BinOp_Which    : swbreak
			
			case "??" : PushToQueue outQueue, nowType, BinOp_NullOr   : swbreak
			
			case "=>" : PushToQueue outQueue, nowType, BinOp_Lambda   : swbreak
			
		;	case"<-->": PushToQueue outQueue, nowType, BinOp_LogEq    : swbreak
			case "-->": PushToQueue outQueue, nowType, BinOp_LogImp   : swbreak
			case "||" : PushToQueue outQueue, nowType, BinOp_LogOr    : swbreak
			case "~~" : PushToQueue outQueue, nowType, BinOp_LogXor   : swbreak
			case "&&" : PushToQueue outQueue, nowType, BinOp_LogAnd   : swbreak
			
			case "===": PushToQueue outQueue, nowType, BinOp_EqRf     : swbreak
			case "!==": PushToQueue outQueue, nowType, BinOp_NeRf     : swbreak
			case "==" : PushToQueue outQueue, nowType, BinOp_Eq       : swbreak
			case "!=" : PushToQueue outQueue, nowType, BinOp_Ne       : swbreak
			case "<"  : PushToQueue outQueue, nowType, BinOp_Lt       : swbreak
			case ">"  : PushToQueue outQueue, nowType, BinOp_Gt       : swbreak
			case "<=" : PushToQueue outQueue, nowType, BinOp_LtEQ     : swbreak
			case ">=" : PushToQueue outQueue, nowType, BinOp_GtEQ     : swbreak
			case "<>" : PushToQueue outQueue, nowType, BinOp_Cmp      : swbreak
			case "<:" : PushToQueue outQueue, nowType, BinOp_Belong   : swbreak
			
			case "<<" : PushToQueue outQueue, nowType, BinOp_ShiftL   : swbreak
			case ">>" : PushToQueue outQueue, nowType, BinOp_ShiftR   : swbreak
			
			case "|"  : PushToQueue outQueue, nowType, BinOp_BitOr    : swbreak
			case "~"  : PushToQueue outQueue, nowType, BinOp_BitXor   : swbreak
			case "&"  : PushToQueue outQueue, nowType, BinOp_BitAnd   : swbreak
			
			case "+"  : PushToQueue outQueue, nowType, BinOp_Add      : swbreak
			case "-"  : PushToQueue outQueue, nowType, BinOp_Sub      : swbreak
			case "*"  : PushToQueue outQueue, nowType, BinOp_Mul      : swbreak
			case "/"  : PushToQueue outQueue, nowType, BinOp_Div      : swbreak
			case "%"  : PushToQueue outQueue, nowType, BinOp_Mod      : swbreak
			
			case "+>" : PushToQueue outQueue, nowType, BinOp_Trans    : swbreak
			
			case "^"  : PushToQueue outQueue, nowType, BinOp_Pow      : swbreak
			case "//" : PushToQueue outQueue, nowType, BinOp_Root     : swbreak
			
			case "."  : PushToQueue outQueue, nowType, BinOp_Assoc     : swbreak
			case "->" : PushToQueue outQueue, nowType, BinOp_AssocBind : swbreak
			
			default:
				logmes "[Error] Unkown Operator Position of " + nowToken
				PutError Error_Syntax
		swend
		
	//-----------------------------------------------
	// ̑
	//-----------------------------------------------
	} else {
	: *LNormalPush
;		logmes "push any (when encode)\n"+ dbgstr(nowType) +"\n"+ dbgstr(nowToken)
		PushToQueue outQueue, nowType, nowToken		// ʏ́Aʂ push
		
	}
	return
	
#global

#endif
